<?php

// QuickTalk guestbook 4.0 build:20200514

// cFileCache can be used as fallback of Memcache deamon
// Methods: connect, get, set, delete
// These methods can return FALSE in case of error: json file not found/writable or repository not found
// By default caches are .json files in directory data/ 

class cFilecache
{

private $root;
public function __construct($root='data/cache/')
{
  if ( !is_string($root) ) die('cFilecache: arg #1 must be a string');
  $this->root = $root.(substr($root,-1,1)==='/' ? '' : '/');
  return $this->connect(); 
}
public function connect()
{
  if ( !is_dir($this->root) )
  { 
    if ( !mkdir($this->root) ) die('Cannot create cache directory: '.$this->root);
  }
  return is_dir($this->root);
}
public function get($key,$json=true,$objAsArr=true)
{
  $ext = $json ? '.json' : '.txt';
  if ( file_exists($this->root.$key.$ext) )
  {
    $obj = file_get_contents($this->root.$key.$ext); // must be utf8 concoded
    if ( $obj===false ) return false;
    if ( !$json ) return $obj;
    return json_decode($obj,$objAsArr);
  }
  return false; 
}
public function set($key,$obj,$json=true,$arrAsObj=true)
{
  $ext = $json ? '.json' : '.txt';
  $h = fopen($this->root.$key.$ext, 'w'); if ( $h===false ) return false;
  if ( $json ) $obj = $arrAsObj ? json_encode($obj,JSON_FORCE_OBJECT) : json_encode($obj);
  if ( fwrite($h,$obj)===false ) { fclose($h); return false; }
  fclose($h);
  return true;
}
public function delete($key)
{
  if ( file_exists($this->root.$key.'.json') ) return unlink($this->root.$key.'.json');
  return false;
}

}