<?php

/*
class cVIP    Includes info on the curent page 
class cMenu   Handles and render menu
class sPopupMsg Handles a message comming from a previous page [static only]
class cHtml   Used to build html basic tags <head> and <body>
->Head()      Returns the <head></head> block including the properties
->Body($arr)  Returns the <body> including the $arr attributes: supported key-values are id,class,style,title,onload,onunload
->end()       Returns the </body></html>
->Redirect    Perform html redirection
->MsgBox      Show
*/

class cVIP
{

public $selfurl;
public $selfname;
public $selfuri;
public $exiturl;
public $exitname;
public $exituri;
function __construct()
{
  $this->selfurl = APP.'_index.php';
  $this->selfname = '';
  $this->selfuri = ''; // URL parameters
  $this->exiturl = APP.'_index.php';
  $this->exitname = 'Back';
  $this->exituri = '';
}

}

// ======

class cHtml
{

public $dtd = '<!DOCTYPE html>'; // default is html 5
public $html = '<html>'; // can be use to include xml attributes (see constructor)
public $title = '';
public $metas = array(); // List of meta declarations. Recommandation: Use the meta 'name' as array key to void double metas when adding a new meta
public $links = array();
public $scripts = array();
public $scripts_end = array();
public $scripts_jq = array();
public $showlog = array(); // Attention if not empty, is VISIBLE at the bottom of the page. 
function Head()
{
  // check loader and modernizr in case of jquery
  if ( !empty($this->scripts_jq) && !isset($this->scripts['jquery']) ) $this->scripts['jquery']=$this->GetJqueryLoader();
  // load metas and scripts (meta can be a string or an array of strings)
  $str = ( is_array($this->metas) ? implode(PHP_EOL,$this->metas) : $this->metas ).PHP_EOL.implode(PHP_EOL,$this->links).PHP_EOL.implode(PHP_EOL,$this->scripts).PHP_EOL;
  if ( !empty($this->scripts_jq) )
  {
    $str .= '<script type="text/javascript">
    function initJQ()
    {
    '.implode(PHP_EOL,$this->scripts_jq).'
    }
    </script>';
  }
  return $this->dtd.PHP_EOL.$this->html.PHP_EOL.'<head>'.PHP_EOL.'<title>'.$this->title.'</title>'.PHP_EOL.$str.PHP_EOL.'</head>'.PHP_EOL;
}
function Body($arr=array())
{
  return '<body'.(isset($arr['id']) ? ' id="'.$arr['id'].'"' : '').(isset($arr['class']) ? ' class="'.$arr['class'].'"' : '').(isset($arr['style']) ? ' style="'.$arr['style'].'"' : '').(isset($arr['title']) ? ' title="'.$arr['title'].'"' : '').(isset($arr['onload']) ? ' onload="'.$arr['onload'].'"' : '').(isset($arr['onunload']) ? ' onunload="'.$arr['onunload'].'"' : '').'>'.PHP_EOL;
}
function End()
{
  $log = empty($this->showlog) ? '' : '<p id="pagelog">'.implode('<br>',$this->showlog).'</p>'.PHP_EOL;
  $this->showlog = array(); // clear log
  return implode(PHP_EOL,$this->scripts_end).PHP_EOL.$log.'</body>'.PHP_EOL.'</html>';
}
public static function Page($i=1,$extraclass='')
{
  switch($i)
  {
  case 1: return PHP_EOL.'<!-- START PAGE -->'.PHP_EOL.'<div id="page"'.(empty($extraclass) ? '' : ' class="'.$extraclass.'"').'>'.PHP_EOL.PHP_EOL; break;
  case -1: return PHP_EOL.'<!-- END PAGE -->'.PHP_EOL.'</div><div id="pagedialog"><span id="pagedialog-ico"></span><span id="pagedialog-txt"></span></div>'.PHP_EOL.PHP_EOL; break;
  default: die('Unknown Html->page value');
  }
}
function Redirect($u='index.php',$s='Continue')
{
  if ( headers_sent() )
  {
  echo '<a href="'.$u.'">',$s,'</a><meta http-equiv="REFRESH" content="0;url='.$u.'">';
  }
  else
  {
  header('Location: '.str_replace('&amp;','&',$u));
  }
  exit;
}
function CloseWindow()
{
  echo '<p><a href="#" onclick="window.close();">'.L('Close').' [x]</a></p><script type="text/javascript">window.close();</script>';
  exit;
}
function Msgbox($strTitle='',$attrBox=array(),$attrTitle=array(),$attrBody=array())
{
  // End msgbox
  if ( $strTitle===-1 ) { echo '</div>',PHP_EOL,'</div>',PHP_EOL; return; }
  // Start msgbox
  // if $attr is a string, next arrays are skipped and $attr is parsed as: [0] box-class, [1] title-class, [2] body-class (and empty classes are replaced by default classnames)
  if ( is_string($attrBox) )
  {
    $arr = explode(',',$attrBox);
    $attrBox  = array(); if ( isset($arr[0]) ) $attrBox['class']  = $arr[0];
    $attrTitle= array(); if ( isset($arr[1]) ) $attrTitle['class']= $arr[1];
    $attrBody = array(); if ( isset($arr[2]) ) $attrBody['class'] = $arr[2];
  }
  // if classes are missing (or empty) use default classes "msgbox" "msgboxtitle', "msgboxbody"
  if ( empty($attrBox['class']) )   $attrBox['class']  ='msgbox';
  if ( empty($attrTitle['class']) ) $attrTitle['class']='msgboxtitle';
  if ( empty($attrBody['class']) )  $attrBody['class'] ='msgboxbody';
  // show box
  echo '<div class="'.$attrBox['class'].'"'.(isset($attrBox['id']) ? ' id="'.$attrBox['id'].'"' : '').(isset($attrBox['style']) ? ' style="'.$attrBox['style'].'"' : '').(isset($attrBox['title']) ? ' title="'.$attrBox['title'].'"' : '').'>'.PHP_EOL;
  echo '<div class="'.$attrTitle['class'].'"'.(isset($attrTitle['id']) ? ' id="'.$attrTitle['id'].'"' : '').(isset($attrTitle['style']) ? ' style="'.$attrTitle['style'].'"' : '').(isset($attrTitle['title']) ? ' title="'.$attrTitle['title'].'"' : '').'>'.$strTitle.'</div>'.PHP_EOL;
  echo '<div class="'.$attrBody['class'].'"'.(isset($attrBody['id']) ? ' id="'.$attrBody['id'].'"' : '').(isset($attrBody['style']) ? ' style="'.$attrBody['style'].'"' : '').(isset($attrBody['title']) ? ' title="'.$attrBody['title'].'"' : '').'>';
}

// PageBox is replaced by PageMsg()
function PageBox($strTitle,$strMessage='Access denied',$strSkin='admin',$intTime=0,$strWidth='300px',$strTitleId='msgboxtitle',$strBodyId='msgbox') { $this->PageMsg($strTitle,$strMessage,$intTime,$strWidth,$strTitleId,$strBodyId,'',$strSkin); }
function PageMsgAdm($strTitle,$strMessage='Access denied',$intTime=0,$strWidth='300px',$strTitleId='msgboxtitle',$strBodyId='msgbox',$root='') { $this->PageMsg($strTitle,$strMessage,$intTime,$strWidth,$strTitleId,$strBodyId,$root,'admin',array('class'=>'fullwidth')); }
function PageMsg($strTitle,$strMessage='Access denied',$intTime=0,$strWidth='300px',$strTitleId='msgboxtitle',$strBodyId='msgbox',$root='',$strSkin='',$arrBodyAttr=array())
{
  global $oP;
  if ( empty($strTitle) ) $strTitle = $oP->selfname;
  if ( empty($strSkin) && !empty($_SESSION[QT]['skin_dir']) ) $strSkin = $_SESSION[QT]['skin_dir'];
  if ( empty($strSkin) ) $strSkin = $root.'admin';
  $this->links   = array();
  $this->links[] = '<link rel="shortcut icon" href="'.$strSkin.'/'.APP.'_icon.ico" />';
  $this->links[] = '<link rel="stylesheet" type="text/css" href="'.$strSkin.'/qt_base.css" />';
  $this->links[] = '<link rel="stylesheet" type="text/css" href="'.$strSkin.'/'.APP.'_layout.css" />';
  $this->links[] = '<link rel="stylesheet" href="'.WEBICONS_CDN.'">';
  $this->links[] = '<link rel="prev" id="exiturl" href="'.$oP->exiturl.'" />';
  echo $this->Head();
  echo $this->Body($arrBodyAttr);
  echo cHtml::Page(1,'pagemsg');
  // in case of error code
  if ( is_int($strTitle) )
  {
    $e = $strTitle;
    if ( $e==99 )
    {
    $strFile = $root.translate('sys_offline.txt',false);
    if ( file_exists($strFile) ) { $strMessage=file_get_contents($strFile); } else { $strMessage='Access denied...'; }
    }
    else
    {
    $strMessage=IncludeError($e);
    }
    $strTitle = '!';
  }
  // display message box
  $this->Msgbox($strTitle,array('style'=>'width:'.$strWidth),array('id'=>$strTitleId),array('id'=>$strBodyId));
  echo $strMessage;
  $this->Msgbox(-1);
  echo cHtml::Page(-1);
  if ( $intTime>0 ) echo '<script type="text/javascript">if ( document.getElementById("exiturl") ) setTimeout(\'window.location=document.getElementById("exiturl").href\',',($intTime*1000),');</script>',PHP_EOL;
  echo $this->end();
  exit;
}
public function GetJqueryLoader()
{
  if ( empty($this->scripts['yepnope']) ) $this->scripts['yepnope']='<script type="text/javascript" src="bin/js/yepnope.js"></script>';
  return '<script type="text/javascript">
  yepnope({
    load:["'.JQUERY_CDN.'","'.JQUERYUI_CDN.'","'.JQUERYUI_CSS_CDN.'"],complete:function(){if(!window.jQuery){yepnope({load:["'.JQUERY_OFF.'","'.JQUERYUI_OFF.'","'.JQUERYUI_CSS_OFF.'"],complete:function(){initJQ();}});}else{initJQ();}}
  });
  </script>';
}
public function DropJquery()
{
  if ( isset($this->scripts['jquery']) ) unset($this->scripts['jquery']);
  if ( isset($this->scripts['jqueryui']) ) unset($this->scripts['jqueryui']);
  if ( isset($this->links['jqueryui']) ) unset($this->links['jqueryui']);
}

}

// ======

class cMenu
{

public $inner; // array of texts or cMenu-objects
public $outer; // outer tag attributes
private $separator = ' ';
private $defaulttag = 'a';
private $hasActive = false;
private $parents=0;
public function __construct($inner='',$outer='', $separator=' ')
{
  $this->inner = is_array($inner) ? $inner : array($inner); // Ensure inner is always an array
  // Check inner are strings or cMenu-objects. Inner cannot be an array of array. If not specified, each string will be enclosed by <a> while each cMenu-object by <div>
  foreach($this->inner as $obj)
  {
    if ( !is_a($obj,'cMenu') && !is_string($obj) ) die('cMenu::constructor#1 must be a an array of strings or cMenu-objects');
    if ( is_a($obj,'cMenu') ) { $this->parents = $obj->parents+1; $this->defaulttag = 'div'; }
  }
  if ( !is_string($outer) ) die('cMenu::constructor#2 must be a string');
  if ( !is_string($separator) ) die('cMenu::constructor#3 must be a string');
  $this->separator = $separator;
  // Initialise outer attributes
  $this->outer = cMenu::iniAttr($outer);
}
public function addInnersAttr($str='')
{
  if ( !is_string($str) || empty($str) || strtolower($str)==='default' ) die('cMenu::addInnersAttr#1 must be a json- or ini-string');
  $attr = cMenu::iniAttr($str); if ( in_array('cMenu::error',$attr) ) die('cMenu::addInnersAttr#1 must be a json'); 
  foreach($this->inner as $k=>$inner)
  {
    if ( !is_a($inner,'cMenu') ) continue;
    $this->inner[$k]->outer = array_merge($this->inner[$k]->outer,$attr);
  } 
}
public function output($active='',$attr='default',$parentattr='',$maxparent=1)
{
  if ( !is_string($active) ) die('cMenu::output#1 must be string');
  if ( !is_string($attr) ) die('cMenu::output#2 must be string');
  if ( strtolower($attr)==='default' ) $attr='{"href":"javascript:void(0)","addclass":"active","onclick":"return false;"}';
  if ( !is_string($parentattr) ) die('cMenu::output#3 must be string');
  if ( !is_int($maxparent) || $maxparent<1 ) die('cMenu::output#4 must be integer (positive)');
  $str = array();
  $activeAttr = cMenu::iniAttr($attr); 
  foreach($this->inner as $inner)
  {
    if ( is_a($inner,'cMenu') )
    {
      $r = $inner->output($active,$attr,$parentattr,$maxparent);
      $this->hasActive = $inner->hasActive;
      $inner = $r;
    }
    
    $str[] = $inner;
    if ( empty($active) ) continue;
    
    // Check if active
    $b = false;
    if ( !empty($this->outer['id']) && $this->outer['id']===$active) $b=true;
    if ( !$b && !empty($this->outer['href']) && substr($this->outer['href'],0,strlen($active))===$active ) $b=true;
    if ( !$b && !empty($this->outer['activewith']) && strstr($this->outer['activewith'],$active) ) $b=true;
    if ( !$b && $this->hasActive ) $b=true;
    if ($b)
    {
      if ( $this->hasActive ) $activeAttr = cMenu::iniAttr($parentattr);
      if ( $this->hasActive && $this->parents>$maxparent ) $activeAttr = array();
      $this->hasActive = true;
      // when active, replaces outer-attributes by active-attributes
      foreach(array_keys($activeAttr) as $k)
      {
        if ( ($k==='tag' && empty($activeAttr[$k])) || $k==='addclass' || $k==='activewith' ) continue; // don't change tag if active-tag is not specified // don't process cMenu private keys
        $this->outer[$k]=$activeAttr[$k];
      }
      // in case of 'addclass' do append
      if ( !empty($activeAttr['addclass']) )
      {
        if ( empty($this->outer['class']) ) {
          $this->outer['class'] = $activeAttr['addclass'];
        } else {
          if ( substr($this->outer['class'], -strlen($activeAttr['addclass'])) !== $activeAttr['addclass'] ) $this->outer['class'] .= ' '.$activeAttr['addclass'];
        }
      }
    }
  }
  if ( empty($this->outer['tag']) ) $this->outer['tag'] = $this->defaulttag;
  return cMenu::renderTag($this->outer).implode($this->separator,$str).'</'.$this->outer['tag'].'>'; 
}
static function iniAttr($str)
{
  $attr = array();
  if ( !empty($str) )
  {
    // convert 'x=y|x=y' to json '{"x":"y","x":"y"}'
    if ( substr($str,0,1)!=='{' || substr($str,-1,1)!=='}' )
    {
      $a = explode('|',trim($str));
      for($i=0;$i<count($a);++$i)
      {
        $b = explode('=',trim($a[$i]),2);
        if ( count($b)===2 ) 
        {
          $b[0] = trim($b[0]); $b[0] = (substr($b[0],0,1)==='"' ? '' : '"').$b[0].(substr($b[0],-1,1)==='"' ? '' : '"');
          $b[1] = trim($b[1]); $b[1] = (substr($b[1],0,1)==='"' ? '' : '"').$b[1].(substr($b[1],-1,1)==='"' ? '' : '"');
        }
        $a[$i] = implode(':',$b);
      }
      $str = '{'.implode(',',$a).'}';
    }
    // decode json
    if ( $str!=='{}' ) $attr = json_decode($str,true);
    if ( empty($attr) || !is_array($attr) ) $attr = array('tag'=>'span','id'=>'cMenu::error','title'=>'definition not readable');
    $attr = array_change_key_case($attr); // W3C recommends attribute-names in lowercase, strict XHTML requires lowercase
  }
  return $attr;
}
static function renderTag($outer)
{
  if ( !is_array($outer) ) die('cMenu::renderTag#1 must be an array');
  if ( empty($outer['tag']) ) die('cMenu::renderTag#1 must includes an tag');
  if ( !empty($outer['addclass']) ) 
  {
    if ( empty($outer['class']) ) {
      $outer['class'] = $outer['addclass'];
    } else {
      if ( substr($outer['class'], -strlen($outer['addclass'])) !== $outer['addclass'] ) $outer['class'] .= ' '.$outer['addclass']; 
    }
  }
  // render basic attributes
  $str  = $outer['tag'];
  $str .= ($outer['tag']==='a' ? ' href="'.(empty($outer['href']) ? 'javascript:void(0)' : $outer['href']).'"' : '');
  foreach(explode(' ','id class title onclick accesskey style') as $k)
  {
    if ( !empty($outer[$k]) ) $str .= ' '.$k.'="'.$outer[$k].'"';
  }
  // in case of extra attributes
  $classattr = explode(' ','tag href id class title onclick accesskey style addclass activewith');
  foreach(array_keys($outer) as $k)
  {
    if ( !in_array($k,$classattr) && !empty($outer[$k]) ) $str .= ' '.$k.'="'.$outer[$k].'"'; 
  }
  return '<'.$str.'>';
}

}

// ========

class sPopupMsg
{

// This class handles a message comming from a previous page (session variable 'pagedialog')
// The message is displayed in a popup block thanks to a jquery function from *_page_header.
// The session variable must be destroyed after display width sPopupMsg::Reset()
// Note: This class replaces cMsg (v3.x class). cMsg was instanciable for backward compatibility, sPopupMsg is static only
public static function getType()
{
  if ( !empty($_SESSION[QT.'pagedialog']) )
  {
  $arr = explode('|',$_SESSION[QT.'pagedialog']);
  return strtolower(substr($arr[0],0,1));
  }
  return 'o'; //i=info, e=error, w=warning, o=ok (default)
}
public static function getTypeIcon()
{
  $type = sPopupMsg::getType();
  switch($type)
  {
  case 'o': return '<i class="qtg-icon icon-check" style="color:green;"></i>'; break;
  case 'e': return '<i class="qtg-icon icon-cancel-circled" style="color:red;"></i>'; break;
  case 'w': return '<i class="qtg-icon icon-attention" style="color:orange;"></i>'; break;
  case 'u': return '<i class="qtg-icon icon-cancel-circled" style="color:red;"></i>'; break;
  case 'l': return '<i class="qtg-icon icon-check" style="color:green;"></i>'; break;
  default: return '<i class="qtg-icon icon-info-circled" style="color:blue;"></i>';
  }
}
public static function getFulltext()
{
  if ( !empty($_SESSION[QT.'pagedialog']) )
  {
  $arr = explode('|',$_SESSION[QT.'pagedialog']);
  $i = (isset($arr[2]) ? (int)$arr[2] : 0);
  if ( isset($arr[1]) ) return str_replace('"','',$arr[1]).($i>1 ? ' ('.$i.')' : '');
  }
  return '';
}
public static function getItems()
{
  if ( !empty($_SESSION[QT.'pagedialog']) )
  {
  $arr = explode('|',$_SESSION[QT.'pagedialog']);
  if ( isset($arr[2]) ) return (int)$arr[2];
  }
  return 0;
}
public static function getText()
{
  if ( !empty($_SESSION[QT.'pagedialog']) )
  {
  $str = sPopupMsg::getFulltext();
  return (isset($str[65]) ? substr($str,0,60).'...' : $str);
  }
  return '';
}
public static function Reset()
{
  $_SESSION[QT.'pagedialog']=null;
}
  
}