<?php

// QuickTalk guestbook version 4.0 build:20200514

class cPost
{

var $id = '-1'; // MUST BE STRING. In case of file system, this is the filename (ipv6 block separator MUST be 'w' in filename) 
var $name = '';
var $message = '';
var $userage = -1;
var $useremail = '';
var $issuedate = '0'; // format YYYYMMDDHHMMSS
var $postfrom = '';
var $visible = 'Y'; // {Y|N|U} U=unknown when reviewer is required (security options) 
var $x = 0;
var $y = 0;
var $z = 0;
var $ip = ''; // ipv6 block separator MUST be ':'

function __construct($aPost=null)
{
  // Note: $aPost can be a [string] id hashed or not
  $this->ip = $_SERVER['REMOTE_ADDR'];
  if ( isset($aPost) )
  {
    if ( is_array($aPost) )
    {
      $this->MakePostFromArray($aPost);
    }
    else
    {
      if ( is_int($aPost) ) $aPost=(string)$aPost; // id must be string
      if ( !is_string($aPost) ) die('Invalide constructor parameter#1 for class cPost');
      global $oDB;
      if ( QT_FILE )
      {
        $this->id = str_replace(':','w',$this->Unhash($aPost));
        if ( file_exists($oDB->Getpath($this->id).$this->id.'.txt') )
        {
        $oDB->arrFiles = array($this->id);
        $oDB->curFiles = 0;
        $row = $oDB->Getrow();
        $this->MakePostFromArray($row);
        }
        else
        {
        echo 'file '.$this->id.'.txt not found';
        }
      }
      else
      {
        if ( $aPost<0 ) die('No post '.$aPost);
        $oDB->Query('SELECT * FROM '.TABMESSAGE.' WHERE id='.$aPost);
        $row = $oDB->Getrow();
        $this->MakePostFromArray($row);
      }
    }
    // override id by filename
    if ( QT_FILE ) $this->id = substr($this->issuedate,0,8).'-'.substr($this->issuedate,8,6).'-'.str_replace(':','w',$this->ip).'-'.strtolower($this->visible);
  }
}

// --------

private function MakePostFromArray($aPost)
{
  if ( !is_array($aPost) ) die('cPost->MakeFromArray: aPost is not an array');
  foreach ($aPost as $strKey => $oValue) {
  switch ($strKey) {
    case 'id':       $this->id = (string)$oValue; break; // id must be string
    case 'name':     $this->name = $oValue; break;
    case 'userage':  $this->userage = intval($oValue); if ($this->userage<0 ) $this->userage = -1; break;
    case 'useremail':$this->useremail = $oValue; break;
    case 'issuedate':$this->issuedate = $oValue; break;
    case 'postfrom': $this->postfrom = $oValue; break;
    case 'visible':  $this->visible = $oValue; break;
    case 'message':  $this->message = $oValue; break;
    case 'textmsg':  $this->message = $oValue; break; // required for firebird
    case 'x':        $this->x = floatval($oValue); break;
    case 'y':        $this->y = floatval($oValue); break;
    case 'z':        $this->z = floatval($oValue); break;
    case 'ip':       $this->ip = $oValue; break;
  }}
}

//----------

public function hasCoord()
{
  if ( !isset($this->y) || !isset($this->x) ) return false;
  if ( $this->y==0 && $this->x==0 ) return false;
  $y = abs($this->y);
  $x = abs($this->x);
  if ( substr((string)$y,0,8)=='0.000000' && substr((string)$x,0,8)=='0.000000' ) return false;
  return true;
}
public function getCoord($round=10)
{
  // Returns string 'Y,X' (rounded) or '' if coordonates are not set.
  return ($this->hasCoord() ? round($this->y,$round).','.round($this->x,$round) : '');
}

//----------

public function CheckMessage($max_size=5000,$min_char=false,$min_word=false)
{
  // check shortness
  if ( $min_char ) { if ( strlen($this->message)<$min_char ) return False; }
  if ( $min_word ) { $str = strtolower(substr($this->message,0,100)); $iWords = str_word_count($str); if ( $iWords < $min_word ) return False; }
  // check longness
  if ( strlen($this->message)>$max_size ) return False;
  // end
  return True;
}
public function CheckContainsUrl($bWWW=false)
{
  // check if message contains 'http' or 'https' url. Optionaly can also check if just 'www.' exists.
  if ( strlen($this->message)<10 ) return false;
  if ( strpos($this->message,'http') )
  {
	  if ( strpos($this->message,'http://') ) return true;
	  if ( strpos($this->message,'https://') ) return true;
  }
  if ( $bWWW && strpos($this->message,'www.') ) return true;
  // end
  return false;
}
public function CheckMeaning()
{
  // no message
  if ( strlen($this->message)<2 ) return false;
  // no letters
  $str = strtolower(substr($this->message,0,200));
  if ( !preg_match('/[a-z]+/',$str) ) return false;
  // check vowels exists
  $str = strtr($str,'éèêëÉÈÊË'  ,'eeeeeeee');
  $str = strtr($str,'áàâäÁÀÂÄÅå','aaaaaaaaaa');
  $str = strtr($str,'íìîïÍÌÎÏ'  ,'iiiiiiii');
  $str = strtr($str,'óòôöÓÒÔÖõÕ','oooooooooo');
  $str = strtr($str,'úùûüÚÙÛÜ'  ,'uuuuuuuu');
  if ( !preg_match('/[aeiouy]+/',$str) ) return false;
  // check random keyboard
  $arrWords = str_word_count($str,1);
  $i=0;
  foreach ( $arrWords as $strWord) {
  foreach ( array('qwe','wqe','qsd','sdf','dfg','fgh','jkl','klm','ghg','fjf','jfj','fgf','dfd','fdj','dfj') as $a ) {
    if ( strpos($strWord,$a)===false ) continue;
    $i++;
  }}
  if ( $i>1 ) return false;
  // check multiple (4 and some 3)
  $str = substr($str,0,50);
  foreach ( array('a','b','c','d','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z') as $a )
  {
    $a = $a.$a.$a.$a;
    if ( strpos($str,$a)===false ) continue;
    return false;
  }
  foreach ( array('b','c','d','f','g','h','j','k','l','m','n','p','q','r','s','t','u','v','z') as $a )
  {
    $a = $a.$a.$a;
    if ( strpos($str,$a)===false ) continue;
    return false;
  }
  // check at least 1/2 words contains vowel
  $intWords = count($arrWords);
  $i=0;
  foreach ($arrWords as $strWord)
  {
    if ( preg_match('/[aeiouy]+/',$strWord) ) $i++;
  }
  if ( $i==0 ) return false;
  if ( $i/$intWords<0.5 ) return false;
  // end control
  Return True;
}
public function CheckWording($voc=array())
{
  if (count($voc)>0)
  {
    $str = strtolower(substr($this->message,0,1000));
    $words = str_word_count($str,1);
    $intwords = array_intersect($voc['good'],$words);
    if (count($intwords)==0) Return FALSE;
    $intwords = array_intersect($voc['bad'],$words);
    $ibad = count($intwords);
    if ($ibad>1) Return FALSE;
  }
  Return True;
}

// --------

public function Insert()
{
  global $oDB;
  if ( empty($this->issuedate) ) $this->issuedate = date('YmdHis');
  if ( QT_FILE )
  {
    $error = '';
    $this->id = substr($this->issuedate,0,8).'-'.substr($this->issuedate,8,6).'-'.str_replace(':','w',$this->ip).'-'.strtolower($this->visible);
    $strPath = $oDB->GetPath($this->id);
    if ( !is_dir($strPath) ) $error = cDT::MakeDir($strPath);
    if ( empty($error) )
    {
      $file = $strPath.$this->id.'.txt';
      $strTxt  = 'name '.$this->name."\r\n";
      $strTxt .= 'userage '.(empty($this->userage) ? '-1' : $this->userage)."\r\n";
      $strTxt .= 'useremail '.(empty($this->useremail) ? '' : $this->useremail)."\r\n";
      $strTxt .= 'postfrom '.(empty($this->postfrom) ? '' : $this->postfrom)."\r\n";
      $strTxt .= 'x '.(empty($this->x) ? '0' : $this->x)."\r\n";
      $strTxt .= 'y '.(empty($this->y) ? '0' : $this->y)."\r\n";
      $strTxt .= 'z '.(empty($this->z) ? '0' : $this->z)."\r\n";
      $strTxt .= 'message '.$this->message;
      $error = saveToFile($file,$strTxt);
    }
    if ( !empty($error) ) echo '<div class="setup_err">',$error,'</div>';
  }
  else
  {
    $this->id = $oDB->Nextid(TABMESSAGE);
    $oDB->Query( 'INSERT INTO '.TABMESSAGE.' (id,name,message,issuedate,userage,useremail,postfrom,ip,x,y,z,visible) VALUES ('.$this->id.',"'.$this->name.'","'.$this->message.'","'.$this->issuedate.'",'.(!empty($this->userage) ? $this->userage : 'NULL').',"'.(!empty($this->useremail) ? $this->useremail : '').'","'.(!empty($this->postfrom) ? $this->postfrom : '').'","'.$this->ip.'",'.$this->x.','.$this->y.',0,"'.$this->visible.'")' );
  }
}

//----------

public function Delete()
{
  global $oDB;
  if ( QT_FILE )
  {
  $this->id = str_replace(':','w',$this->id); // filename format
  // get month path
  $strPath = $oDB->GetPath($this->id);
  if ( file_exists($strPath.$this->id.'.txt') ) unlink($strPath.$this->id.'.txt');
  }
  else
  {
  $oDB->Query('DELETE FROM '.TABMESSAGE.' WHERE id='.$this->id);
  }
}

//----------

public function Update($bResetdate=false)
{
  global $oDB;
  if ( QT_FILE )
  {
  $this->Delete();
  $this->issuedate = $bResetdate ? date('Ymd His') : $this->issuedate;
  $this->Insert();
  }
  else
  {
  $this->issuedate = $bResetdate ? date('YmdHis') : $this->issuedate;
  $oDB->Query( 'DELETE FROM '.TABMESSAGE.' WHERE id='.$this->id );
  $oDB->Query( 'INSERT INTO '.TABMESSAGE.' (id,name,message,issuedate,userage,useremail,postfrom,ip,x,y,z,visible) VALUES ('.$this->id.',"'.$this->name.'","'.$this->message.'","'.$this->issuedate.'",'.(!empty($this->userage) ? $this->userage : 'NULL').',"'.(!empty($this->useremail) ? $this->useremail : '').'","'.(!empty($this->postfrom) ? $this->postfrom : '').'","'.$this->ip.'",'.$this->x.','.$this->y.',0,"'.$this->visible.'")' );
  }
}

//----------

public function SetStatus($str='Y')
{
  if ( $str!=='Y' && $str!=='N' && $str!=='U' ) die ('SetStatus: invalid status');
  global $oDB;
  if ( QT_FILE )
  {
  $this->id = str_replace(':','w',$this->id); // filename format
  $strPath = $oDB->GetPath($this->id);
  if ( file_exists($strPath.$this->id.'.txt') ) rename($strPath.$this->id.'.txt',$strPath.substr($this->id,0,-1).strtolower($str).'.txt');
  }
  else
  {
  $oDB->Exec('UPDATE '.TABMESSAGE.' SET visible="'.$str.'" WHERE id='.$this->id);
  }
}

public static function ChangeAllUStatus($str='N')
{
  if ( $str!=='Y' && $str!=='N' ) die ('ChangeAllUStatus: invalid status');
  global $oDB;
  if ( QT_FILE )
  {
    $arr =$oDB->GetFiles('u');
    foreach($arr as $id)
    {
    $id = str_replace(':','w',$id); // filename format
    $strPath = $oDB->GetPath($id);
    if ( file_exists($strPath.$id.'.txt') ) rename($strPath.$id.'.txt',$strPath.substr($id,0,-1).strtolower($str).'.txt');
    }
  }
  else
  {
    $oDB->Exec('UPDATE '.TABMESSAGE.' SET visible="'.$str.'" WHERE visible="U"');
  }
}

//------

public static function Hash($str)
{
  if ( !QT_FILE ) return $str;
  if ( is_int($str) ) die('cPost->Hash: invalid argument, must be a string');
  if ( empty($str) ) die('cPost->Hash: invalid argument is empty');
  $arr = explode('-',$str); if ( count($arr)!==4 ) return $str;
  $arr[0] = dechex(intval($arr[0])*2); // hexdec(x2) date
  $arr[1] = dechex(intval($arr[1])*2); // hexdec(x2) time
  $arr[2] = str_replace(array('.',':'),array('v','w'),$arr[2]); // seperator is v for ipv4, w for ipv6
  return implode('x',$arr);
}

public static function Unhash($str)
{
  if ( !QT_FILE ) return $str;
  if ( is_int($str) ) die('cPost->Unhash: invalid argument, must be a string');
  if ( empty($str) ) die('cPost->Unhash: invalid argument is empty');
  $arr = explode('x',$str); if ( count($arr)!==4 ) return $str;
  $arr[0] = strval(hexdec($arr[0])/2);
  $arr[1] = substr('000000'.strval(hexdec($arr[1])/2),-6);
  $arr[2] = str_replace(array('v','w'),array('.',':'),$arr[2]); // seperator is v for ipv4, w for ipv6
  return implode('-',$arr);
}

//----------

}