<?php // v4.0 build:20210526

function makeFormCertificate($publickey)
{
  if ( empty($publickey) || !is_string($publickey) ) die('cannot make certificate');
  switch($publickey) {
  case 'd29e6fce729a7cb125ebc276d3e37b4c':
  case '3bccd4c53e045fbe250d6c9d9e7ff7be':
  case 'bfaa317f62e9cc73a649a45124c9a050': return md5($publickey.APP.$_SERVER['REMOTE_ADDR'].QT_HASHKEY);
  }
  die('cannot make certificate');
  // Allow checking that POST requests come from a qtg page
}

// memcacheCreate() initialize and open connection (if MEMCACHE_HOST is defined). Can return false with a warning message.
// When no reply (or MEMCACHE_HOST not defined), memcacheCreate() use a file cache system (class cFilecache)
// memcacheGet()-Set()-Unset()-Flush() use global $cache returned by memcacheCreate
// Note: These functions return FALSE in case of failure (when memcache not enabled or daemon/file not responding). It's thus not recommended to use Set a FALSE value
function memcacheCreate(&$warning)
{
  $cache=false;
  if ( MEMCACHE_HOST )
  {
    if ( class_exists('Memcache') )
    {
    $cache = new Memcache;
    if ( !$cache->connect(MEMCACHE_HOST,MEMCACHE_PORT) ) { $warning='Unable to contact memcache daemon ['.MEMCACHE_HOST.' port '.MEMCACHE_PORT.']. Turn this option to false in '.APP.'_init...'; $cache=false; }
    }
    else
    {
    $warning='Memcache library not found. Turn this option to false in '.APP.'_init...';
    $cache=false;
    }
  }
  // fallback using json files in data/cache/
  if ( !$cache && MEMCACHE_FALLBACK )
  {
    include 'bin/class/class.qtg.cache.php';
    $cache = New cFilecache(MEMCACHE_FALLBACK);
  }
  return $cache; // returns FALSE or a Memcache/cFilecache object
}
function memcacheGet($key,$encode=true)
{
  global $cache;
  if ( is_a($cache,'cFilecache') ) return $cache ? $cache->get($key,$encode) : false; // filecache can encode json or use txt
  return $cache ? $cache->get($key) : false;
}
function memcacheSet($key,$obj,$encode=true)
{
  global $cache;
  if ( is_a($cache,'cFilecache') ) return $cache ? $cache->set($key,$obj,$encode) : false; // filecache can encode json or use txt
  return $cache ? $cache->set($key,$obj,false,MEMCACHE_TIMEOUT) : false;
}
function memcacheUnset($key)
{
  global $cache; return $cache ? $cache->delete($key) : false;
}
function memcacheFlush()
{
  // Memcache
  global $cache; if ( $cache===false ) return false;
  // Dont use memcache::flush if several app on the same server
  memcacheUnset(QT.'-countYfile');
  memcacheUnset(QT.'-countYrow');
  memcacheUnset(QT.'-countAll');
  memcacheUnset(QT.'-countU');
  foreach(array_keys(LANGUAGES) as $iso) memcacheUnset(QT.'-page1'.$iso);
  memcacheUnset(QT.'-coord');
  memcacheUnset(QT.'-stats');
  memcacheUnset(QT.'-ips');
  return true;
}

function IncludeError($i=0)
{
  include translate(APP.'_error.php');
  return isset($e[$i]) ? $e[$i]: 'Error '.$i;
}
function CountMessages($oDB,$option='',$filesubset=false)
{
  // $option can be '' (all messages), 'y', 'n', 'u' (visible status) or a csv of 2 status. Ex: 'n;u'
  // Note: with file system 'n;u' becomes to '-n' or '-u'
  // Note: with db system 'n;u' becomes visible="N" OR visible="U"
  $i=0;
  if ( QT_FILE )
  {
    // When using file repository, filesubset allows to count from the $oDB->arrFiles list
    $i = $filesubset ? count($oDB->GetFilesSubset($option)) : $oDB->FilesCount($option);
  }
  else
  {
    if ( empty($option) )
    {
      $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0' );
    }
    else
    {
      $options = array_filter(array_map('trim',explode(';',$option)));
      foreach($options as $k=>$v) $options[$k]='visible="'.strtoupper($v).'"';
      $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND ('.implode(' OR ',$options).')');
    }
    if ( $row=$oDB->Getrow() ) $i=(int)$row['countid'];
  }
  return $i;
}
function GetURI($reject=array())
{
  // Returns the URI not urldecoded as a string
  // $reject to remove parametres from the URI (can be csv)
  if ( !is_array($reject) ) $reject=explode(',',$reject);
  $arr = QTexplodeUri();
  foreach($reject as $key) $arr = QTarradd($arr,trim($key),null); // null value to remove the key
  return QTimplode($arr);
}
function AsEmails($emails,$id,$render='txt',$first=0,$empty='',$separator=';')
{
  // Converts email(s) into a string like <a href="mailto:...">...</a> or java protected text/image
  // $emails {string|csv-string|array-of-string}. Values will be trimmed and empty values removed
  // $id required for java protected email.
  // $render {txt|img|txtjava|imgjava} to render email(s) as text, image or java protected txt/image
  // $first number of emails allowed: {false|0}=all, {true|1}=first, 2=top2,... (negative drops last emails)
  if ( empty($emails) ) return $empty;
  if ( is_string($emails) && strstr($emails,$separator) ) $emails = explode($separator,$emails);
  if ( is_string($emails) ) $emails = array($emails);
  if ( !is_array($emails) ) return $empty;
  foreach($emails as $k=>$v) if ( !is_string($v) || empty(trim($v)) ) {unset($emails[$k]);} else {$emails[$k]=trim($v);} // trim and remove empty
  // get first emails
  if ( $first ) $emails = array_slice($emails,0,(int)$first);
  if ( empty($emails) ) return $empty;
  // returns by render type
  switch ($render)
  {
  case 'txt':
    return '<a id="href'.$id.'" class="mail" href="mailto:'.implode(';',$emails).'">'.implode(';',$emails).'</a>';
  case 'img':
    $title = reset($emails).(count($emails)>1 ? '...' : ''); // title with the first (add ... if several)
    return '<a id="href'.$id.'" class="mail" href="mailto:'.implode(';',$emails).'"><i id="img'.$id.'" class="qtg-icon icon-mail-alt" title="'.$title.'"></i></a>';
  case 'txtjava':
    $str = '';
    foreach ($emails as $email) { $arr = explode('@',$email); $str .= 'writemailto("'.$arr[0].'","'.$arr[1].'"," ");'; }
    return '<script type="text/javascript">'.$str.'</script>';
  case 'imgjava':
    $str = str_replace(array('@','.'),array('-at-','-dot-'),implode(';',$emails));
    $title = str_replace(array('@','.'),array('-at-','-dot-'),reset($emails)).(count($emails)>1 ? '...' : ''); // title with the first (add ... if several)
    return '<a id="href'.$id.'" class="mail" onmouseover="vmail(\''.$id.'\');" onmouseout="hmail(\''.$id.'\');" href="jm#'.$str.'"><i id="img'.$id.'" class="qtg-icon icon-mail-alt" title="'.$title.'"></i></a>';
  }
  return $empty; // unknown render
}
function DateAdd(string $d='0', int $i=-1, string $str='year')
{
   if ( $d=='0' ) die('DateAdd:#1 must be a string');

   $intY = (int)substr($d,0,4);
   $intM = (int)substr($d,4,2);
   $intD = (int)substr($d,6,2);
   switch($str)
   {
   case 'year': $intY += $i; break;
   case 'month': $intM += $i; break;
   case 'day': $intD += $i; break;
   }
   if ( in_array($intM,array(1,3,5,7,8,10,12)) && $intD>31 ) { $intM++; $intD -= 31; }
   if ( in_array($intM,array(4,6,9,11)) && $intD>30 ) { $intM++; $intD -= 30; }
   if ( $intD<1 ) { --$intM; $intD += 30; }
   if ( $intM>12 ) { ++$intY; $intM -= 12; }
   if ( $intM<1 ) { --$intY; $intM += 12; }
   if ( $intM===2 && $intD>28 ) { ++$intM; $intD -= 28; }
   return strval($intY*10000+$intM*100+$intD).(strlen($d)>8 ? substr($d,8) : '');
}
function HtmlRedirect($u='qtg_index.php',$s='Continue')
{
  if ( headers_sent() )
  {
  echo '<a href="'.$u.'">',$s,'</a><meta http-equiv="REFRESH" content="0;url='.$u.'">';
  }
  else
  {
  header('Location: '.str_replace('&amp;','&',$u));
  }
  exit;
}
function LimitSQL($strState,$strOrder,$intStart=0,$intLength=50)
{
  global $oDB;
  $strOrder = trim($strOrder); if ( substr($strOrder,-3,3)!=='ASC' && substr($strOrder,-4,4)!=='DESC' ) $strOrder .= ' ASC';
  switch($oDB->type)
  {
    case 'pdo.mysql': return 'SELECT '.$strState.' ORDER BY '.$strOrder.' LIMIT '.$intStart.','.$intLength; break;
    case 'pdo.sqlsrv':
    case 'sqlsrv': return ($intStart===0 ? "SELECT TOP $intLength $strState ORDER BY $strOrder" : "WITH OrderedRows AS (SELECT ROW_NUMBER() OVER (ORDER BY $strOrder) AS RowNumber, $strState) SELECT * FROM OrderedRows WHERE RowNumber BETWEEN ".($intStart+1)." AND ".($intStart+$intLength)); break;
    case 'pdo.pg':
    case 'pg': return "SELECT $strState ORDER BY $strOrder LIMIT $intLength OFFSET $intStart"; break;
    case 'pdo.sqlite':
    case 'sqlite': return "SELECT $strState ORDER BY $strOrder LIMIT $intLength OFFSET $intStart"; break;
    case 'pdo.oci':
    case 'oci': return ($intStart===0 ? "SELECT * FROM (SELECT $strState ORDER BY $strOrder) WHERE ROWNUM<$intLength" : "SELECT * FROM (SELECT a.*, rownum RN FROM (SELECT $strState ORDER BY $strOrder) a WHERE rownum<$intStart+1+$intLength) WHERE rn>=$intStart"); break;
    default: return 'SELECT '.$strState.' ORDER BY '.$strOrder.' LIMIT '.$intStart.','.$intLength; break;
  }
}
function MakePager($uri,$count,$intPagesize=50,$currentpage=1,$currentclass='current')
{
  $arrUri = parse_url($uri);
  $arrArg = array();
  $arrNew = array();
  $uri = Href($arrUri['path']);
  if ( isset($arrUri['query'])) $arrArg = explode('&',str_replace('&amp;','&',$arrUri['query']));

  foreach($arrArg as $strValue)
  {
    if ( substr($strValue,0,4)==='page' ) continue;
    $arrNew[]=$strValue;
  }
  $arg = implode('&amp;',$arrNew);

  $strPages='';
  $firstpage='';
  $lastpage='';
  $top = ceil($count/$intPagesize);
  if ( $currentpage<5 )
  {
    $arrPages=array(1,2,3,4,5);
  }
  elseif ( $currentpage===$top )
  {
    $arrPages=array($currentpage-4,$currentpage-3,$currentpage-2,$currentpage-1,$currentpage);
  }
  else
  {
    $arrPages=array($currentpage-2,$currentpage-1,$currentpage,$currentpage+1,$currentpage+2);
  }

  // pages
  foreach($arrPages as $page)
  {
    if ( $count>$intPagesize && $page>=1 && $page<=$top )
    {
    $strPages .= ' '.($currentpage===$page ? '<span class="'.$currentclass.'">'.$page.'</span>' : '<a href="'.$uri.'?'.$arg.'&amp;page='.$page.'">'.$page.'</a>');
    }
  }
  // extreme
  if ( $count>($intPagesize*5) )
  {
    if ( $arrPages[0]>1 ) $firstpage = ' <a href="'.$uri.'?'.$arg.'&amp;page=1" title="'.L('First').'">&laquo;</a>';
    if ( $arrPages[4]<$top ) $lastpage = ' <a href="'.$uri.'?'.$arg.'&amp;page='.$top.'" title="'.L('Last').': '.$top.'">&raquo;</a>';
  }
  return $firstpage.$strPages.$lastpage;
}
function LastPostDelayAcceptable($max=5)
{
  if ( isset($_SESSION['qtg_beginedit']) ) {
  if ( !empty($_SESSION['qtg_beginedit']) ) {
    if ( $_SESSION['qtg_beginedit']+$max >= time() ) return FALSE;
  }}
  return TRUE;
}
function TooMuch($qtg_max_day=5)
{
  global $oDB;
  $now = date('Ymd'); // to avoid having different date() inside this function (if response-time is long), we lock the date argument
  if ( QT_FILE )
  {
    // search this ip only in the directory of this month
    $arr = $oDB->GetFiles($_SERVER['REMOTE_ADDR'],$qtg_max_day+1,substr($now,0,6),substr($now,0,6));
    if (count($arr)<=$qtg_max_day) return FALSE;
    // search further for this date only
    $i=0;
    foreach($arr as $str)
    {
    if ( substr($str,0,8)===$now ) $i++;
    if ( $i>=$qtg_max_day ) return TRUE;
    }
  }
  else
  {
    switch($oDB->type)
    {
    case 'sqlite': $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE ip="'.$_SERVER['REMOTE_ADDR'].'" AND SUBSTR(issuedate,1,8)="'.$now.'"' ); break;
    case 'oci':    $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE ip="'.$_SERVER['REMOTE_ADDR'].'" AND SUBSTR(issuedate,1,8)="'.$now.'"' ); break;
    default:       $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE ip="'.$_SERVER['REMOTE_ADDR'].'" AND SUBSTRING(issuedate,1,8)="'.$now.'"' );
    }
    $row = $oDB->Getrow();
    if ($row['countid']>=$qtg_max_day) return TRUE;
  }
  return FALSE;
}
function MoreLink($intMsg=200,$maxlen=200,$hid='',$page=0,$noJava=false)
{
  if ( empty($maxlen) || !is_int($maxlen) ) return ''; // 0 or null means no link
  if ( $intMsg>$maxlen )
  {
    if ( $noJava || $intMsg>800 || $intMsg>$maxlen*3 )
    {
    return ' <a id="more-'.$hid.'" class="more-link" href="qtg_msg_view.php?id='.$hid.'&page='.$page.'">'.L('More').'</a>';
    }
    return ' <a id="more-'.$hid.'" class="more-link" href="javascript:void(0)" onclick="msgSwitch(\''.$hid.'\');">'.L('More').'</a>';
  }
  return '';
}
function RenderSmile($strMsg,$tags=array(),$skin='skin/default')
{
  if ( strpos($strMsg,'[')!==false ) {
  if ( in_array(':)',$tags) ) {
    $strMsg = str_replace( array('[:)]','[:(]','[:|]','[;)]','[:t]','[:o]','[:?]','[:!]','[:*]'),
    array
    (
    '<img class="smile" src="'.$skin.'/ico_smile_01.gif" alt="[:)]" title="'.Lh('Ico_smile01').'"/>',
    '<img class="smile" src="'.$skin.'/ico_smile_02.gif" alt="[:(]" title="'.Lh('Ico_smile02').'"/>',
    '<img class="smile" src="'.$skin.'/ico_smile_03.gif" alt="[:|]" title="'.Lh('Ico_smile03').'"/>',
    '<img class="smile" src="'.$skin.'/ico_smile_04.gif" alt="[;)]" title="'.Lh('Ico_smile04').'"/>',
    '<img class="smile" src="'.$skin.'/ico_smile_05.gif" alt="[:t]" title="'.Lh('Ico_smile05').'"/>',
    '<img class="smile" src="'.$skin.'/ico_smile_06.gif" alt="[:o]" title="'.Lh('Ico_smile06').'"/>',
    '<img class="smile" src="'.$skin.'/ico_smile_07.gif" alt="[:?]" title="'.Lh('Ico_smile07').'"/>',
    '<img class="smile" src="'.$skin.'/ico_smile_08.gif" alt="[:!]" title="'.Lh('Ico_smile08').'"/>',
    '<img class="smile" src="'.$skin.'/ico_smile_09.gif" alt="[:*]" title="'.Lh('Ico_smile09').'"/>',
    ),
    $strMsg);
  }}
  return $strMsg;
}
function RenderMsgHeader($oPost,$bFrom=false)
{
	if ( !is_a($oPost,'cPost') ) return 'invalid header data';
  return ($bFrom && !empty($oPost->postfrom) ? '<span class="msg-from">'.$oPost->postfrom.', </span>' : '' ).'<span class="msg-date">'.QTdatestr($oPost->issuedate,FORMATDATE,FORMATTIME,true).'</span>';
}
function RenderMsgFooter($oPost,$bMail=false,$bAge=false,$bMap=false,$bCheckEdit=true,$bJavaRender=false)
{
	if ( !is_a($oPost,'cPost') ) return 'invalid footer data';
	$str = '<span class="msg-name">'.$oPost->name.'</span>';
	if ( $bAge && $oPost->userage>0 ) $str .= ' <span class="msg-age" title="'.Lh('Age').'">('.$oPost->userage.')</span>';
	if ( $bMail && !empty($oPost->useremail) ) $str .= ' '.AsEmails($oPost->useremail,$oPost->id,'img'.(QT_JAVAMAIL ? 'java' : ''),1); // only 1 email
	if ( $bMap ) {
	if ( $oPost->hasCoord() ) {
	  $y = floatval($oPost->y);
	  $x = floatval($oPost->x);
	  $str .= ' <a class="coord" href="#map_canvas" onclick="gmapPan(\''.$oPost->getCoord().'\');"><i class="qtg-icon icon-location" title="'.Lh('map_Coord_latlon').' '.QTdd2dms($y).','.QTdd2dms($x).'"></i></a>';
	}}
	if ( $bCheckEdit )
  {
    if ( $_SERVER['REMOTE_ADDR']==$oPost->ip ) {
    if ( isset($_SESSION['qtg_beginedit']) && isset($_SESSION['qtg_endedit']) ) {
    if ( $oPost->issuedate >= date('YmdHis',$_SESSION['qtg_beginedit']) && $oPost->issuedate < date('YmdHis',$_SESSION['qtg_endedit']) ) {
      if ( time()+0 < $_SESSION['qtg_endedit'] )
      {
        if ( $bJavaRender )
        {
        $str .= '<span style="display:none" id="'.md5('cmd-'.$oPost->ip).'" data-id="'.cPost::Hash($oPost->id).'" data-time="'.(time()+300).'"></span>';
        }
        else
        {
        $str .= ' <a href="'.Href('qtg_msg_edit.php').'?id='.cPost::Hash($oPost->id).'">['.L('Edit').'...]</a> <a href="'.Href('qtg_msg_del.php').'?id='.cPost::Hash($oPost->id).'">['.L('Delete').'...]</a>';
        }
      }
      else
      {
      unset($_SESSION['qtg_endedit']);
      unset($_SESSION['qtg_beginedit']);
      }
    }}}
  }
  return $str;
}
function RenderMsg($strMsg,$maxlen=100,$tags=array(),$end='...',$skin='skin/default',$nl='<br>')
{
  if ( !is_string($strMsg) ) die('RenderMsg:#1 must be a string');
  if ( empty($maxlen) ) $maxlen = 99999; // 0 or null means maximum
  if ( !is_int($maxlen) || $maxlen<64 ) die('RenderMsg:#2 must be an integer (minimum 64)');
  if ( !is_array($tags) ) die('RenderMsg:#3 must be an array');
  if ( !is_string($end) ) die('RenderMsg:#4 must be a string');
  if ( !is_string($skin) ) die('RenderMsg:#5 must be a string');
  if ( !is_string($nl) ) die('RenderMsg:#6 must be a string');
  $truncated=false;

  // DROP UNALLOWED BBC TAGS (if '[' exists)

  if ( strpos($strMsg,'[')!==FALSE )
  {
    if ( !in_array('b',$tags) ) $strMsg = preg_replace("/\[b\](.*?)\[\/b\]/","\$1", $strMsg);
    if ( !in_array('i',$tags) ) $strMsg = preg_replace("/\[i\](.*?)\[\/i\]/","\$1", $strMsg);
    if ( !in_array('u',$tags) ) $strMsg = preg_replace("/\[u\](.*?)\[\/u\]/","\$1", $strMsg);
    if ( !in_array('url',$tags) ) $strMsg = preg_replace("/\[url\](.*?)\[\/url\]/","\$1", $strMsg);
    if ( !in_array(':)',$tags) ) $strMsg = preg_replace("/\[:(.*?)\]/","", $strMsg);
  }

  // TRUNCATE (don't cut if within smartcut tolerance)

  if ( strlen($strMsg)>$maxlen+QT_SMARTCUT )
  {
    // if some caracters are at the cut-position, cut after
    switch( substr($strMsg,$maxlen,1) )
    {
    case ']': $maxlen++; break;
    case '.': $maxlen++; break;
    case ',': $maxlen++; break;
    case ':': $maxlen++; break;
    case '!': $maxlen++; break;
    case '?': $maxlen++; break;
    case ')': $maxlen++; break;
    case ';': $maxlen++; break;
    case '}': $maxlen++; break;
    }
    // cut
    $strMsg=substr($strMsg,0,$maxlen);
    $truncated=true;
    // if missing closing tag, add it
    if ( strpos($strMsg,'[')!==false )
    {
      foreach ($tags as $tag)
      {
        if ( substr($tag,0,1)==='/' || substr($tag,0,1)===':' ) continue; // skip closing tag and smiley
        $i = strrpos($strMsg,'['.$tag.']'); // search last opened-tag
        if ( $i===false ) continue;
        $j = strrpos($strMsg,'[/'.$tag.']'); // search last closed-tag
        if ( $j===false || $j<$i ) $strMsg .= '[/'.$tag.']';
      }
    }
  }

  // FORMAT THE MESSAGE

  $strMsg = QTbbc($strMsg,$nl);

  // FORMAT THE SMILEY (if exists and allowed)

  $strMsg = RenderSmile($strMsg,$tags,$skin);

  // RETURN
  if ( $truncated ) $strMsg .= $end; // add '...' if truncated
  return $strMsg;
}
function PrevMonth($str)
{
  if ( is_int($str) ) $str=strval($str);
  if ( !is_string($str) ) die('PrevMonth: arg #1 must be a string');

  $y = intval(substr($str,0,4));
  $m = intval(substr($str,4,2));
  $m--; if ( $m<1 ) { $m=12; $y--; }
  return strval($y*100+$m);
}
function saveToFile(string $file, string $str='', bool $create=true)
{
  if ( empty($file) )  die('saveToFile:#1 must be a string');
  $error = '';
  // Stop of no file and creation not allowed
  if ( !file_exists($file) && !$create ) return 'Impossible to open the file ['.$file.'].';
  // Update file (or create file)
  if ( !$handle=fopen($file, 'w') ) $error='Impossible to open the file ['.$file.'].';
  if ( empty($error) )
  {
    if ( fwrite($handle,$str)===FALSE )
    {
      $error = 'Impossible to write into the file ['.$file.'].';
    }
    else
    {
      fclose($handle);
    }
  }
  return $error;
}