<?php

/*
* QuickTalk Guestbook
*
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk Guestbook
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @license    http://www.php.net/license  PHP License 3.0
* @version    4.0 build:20200419
*/

session_start();

$oVIP->selfname='';
if ( empty($_SESSION['qtgAuth']) ) HtmlRedirect('qtg_adm_login.php'); // CHECK LOGIN

require_once('qtg_init.php');
include getLangDir().'qtg_adm.php';

$qtg_skin='bin/css';

// CHECK ARGUMENTS

if ( !isset($_GET['y']) ) die ('Missing argument [y]');
if ( !isset($_GET['m']) ) die ('Missing argument [m]');
if ( !isset($_GET['ip']) ) die ('Missing argument [ip]');
if ( !isset($_GET['n']) ) die ('Missing argument [n]');

// READ ARGUMENTS (protection against injection)

$intYear = intval($_GET['y']);
$intMonth = intval($_GET['m']);
$strIp = strip_tags(substr($_GET['ip'],0,30));
$intNum = intval($_GET['n']);

$bHidden = true;
$bBbc = true;
$bSmile = true;
if ( isset($_GET['f']) ) { $f=substr($_GET['f'],0,3); } else { $f='txt'; }
if ( isset($_GET['h']) ) { if ( $_GET['h']=='N' ) $bHidden=false; }
if ( isset($_GET['b']) ) { if ( $_GET['b']=='N' ) $bBbc=false; }
if ( isset($_GET['s']) ) { if ( $_GET['s']=='N' ) $bSmile=false; }

// --------
// SUBMITTED
// --------

$str = strval($intYear); if ( $intMonth>0 ) $str = strval($intYear*100+$intMonth);
switch($oDB->type)
{
case 'mysql4':
case 'mysql': $strWhere = 'SUBSTRING(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
case 'sqlsrv':
case 'mssql': $strWhere = 'SUBSTRING(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
case 'pg':    $strWhere = 'SUBSTRING(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
case 'sqlite':$strWhere = 'SUBSTR(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
case 'ifx':   $strWhere = 'SUBSTRING(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
case 'oci':   $strWhere = 'SUBSTR(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
default: die('Unknown db type '.$oDB->type);
}
if ( !empty($strIp) )$strWhere .= ' AND ip="'.$strIp.'"';

$oDB->Query( 'SELECT * FROM '.TABMESSAGE.' WHERE '.$strWhere.($bHidden ? '' : ' AND visible="Y"') );

if (!headers_sent())
{
header('Content-Type: text/plain; charset='.$L['Html_charset']);
header('Content-Disposition: attachment; filename="qt_'.date('Ymd').'.'.$f);
}
else
{
echo '<p>Hearder send</p>';
}

while ( $row = $oDB->Getrow() )
{
  $msg = new cPost($row,$oDB);

  if ( $bBbc || $bSmile )
  {
    if ( strstr($msg->message,'[') )
    {
      if ( $bBbc )   $msg->message=QTbbc($msg->message,'deepdrop');
      if ( $bSmile ) $msg->message=ereg_replace('\[(\:|\;).\]','',$msg->message);
    }
    if ( strstr($msg->name,'[') )
    {
      if ( $bBbc )   $msg->name=QTbbc($msg->name,'deepdrop');
      if ( $bSmile ) $msg->name=ereg_replace('\[(\:|\;).\]','',$msg->name);
    }
  }
  if ( $f=='txt' )
  {
    $msg->message = QThtml2text($msg->message);
    $msg->name = QThtml2text($msg->name);
    echo $msg->name;
    if ( !empty($msg->userage) )   echo " ($msg->userage)";
    if ( !empty($msg->useremail) ) echo ", $msg->useremail";
    if ( !empty($msg->postfrom) )  echo ", $msg->postfrom";
    if ( !empty($msg->issuedate) ) echo " ".QTdate($msg->issuedate,array('n','datetime','j-n-Y',$qtg_formattime));
    echo "\r\n\r\n".$msg->message;
    echo "\r\n___________________________\r\n\r\n";
  }
  if ( $f=='csv' )
  {
    $msg->message = '"'.QThtml2text($msg->message,"'").'"';
    $msg->name = '"'.QThtml2text($msg->name,"'").'"';
    $msg->message = str_replace("\r\n","\n",$msg->message);
    $msg->message = str_replace("\n","\\n",$msg->message);
    echo $msg->id.','.$msg->name.';';
    if ( !empty($msg->userage) )   { echo $msg->userage.';'; } else { echo '0;'; }
    if ( !empty($msg->useremail) ) { echo '"'.$msg->useremail.'";'; } else { echo '"";'; }
    if ( !empty($msg->postfrom) )  { echo '"'.$msg->postfrom.'";'; } else { echo '"";'; }
    echo '"'.$msg->issuedate.'";';
    echo '"'.$msg->x.'";';
    echo '"'.$msg->y.'";';
    echo '"'.$msg->z.'";';
    echo $msg->message."\r\n";
  }
}