<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk Guestbook
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2009-2012 The PHP Group
* @version    4.0.3 build:20220105
*/

session_start();
/**
 * @var cVIP $oP
 * @var cHtml $oHtml
 * @var array $L
 * @var cDB $oDB
 */
require 'qtg_init.php';
$qtg_skin='bin/css';

// INITIALISE

$ok = '';
$usr = '';
$pwd = '';
QThttp('ok usr pwd');
$oVIP->selfurl='qtg_adm_login.php';
$oVIP->selfname=L('Administration').' - '.L('login') ;
$bJava=false;

// Check install

if ( !isset($qtg_install) ) $qtg_install='';
if ( empty($qtg_install) )
{
  if ( file_exists('install/index.php') )
  {
  echo '
  <p>QuickTalk ',QTGVERSION,' <a id="exiturl" href="install/index.php">starting installation or upgrade</a>...</p>
  <script type="text/javascript">setTimeout(\'window.location=document.getElementById("exiturl").href\',0);</script>
  ';
  exit;
  }
}

// --------
// SUBMITTED for log-in
// --------

if ( !empty($ok) )
{
  // CHECK FORM VALUE
  if ( !QTislogin($usr,2) ) $oVIP->err = $L['Username'].' '.$L['E_invalid'];
  if ( !QTispassword($pwd,2) ) $oVIP->err = $L['Password'].' '.$L['E_invalid'];

  // check login
  if ( empty($error) )
  {
    if ( ($usr!=$qtg_user) && ($usr!=$qtg_user_2) ) $oVIP->err=$L['E_access_denied'];
  }
  // check pwd
  if ( empty($error) )
  {
    if ( ($usr==$qtg_user) && ($pwd!=$qtg_pwd) ) $oVIP->err=$L['E_access_denied'];
    if ( ($usr==$qtg_user_2) && ($pwd!=$qtg_pwd_2) ) $oVIP->err=$L['E_access_denied'];
  }

  // execute
  if ( empty($oVIP->err) )
  {
  $_SESSION['qtgAuth'] = 'yes';
  $oHtml->Redirect('qtg_adm.php');
  }
}

// --------
// SUBMITTED for log-out
// --------

if ( isset($_GET['a']) ) {
if ( $_GET['a']==='out' ) {
  session_destroy();
  $oHtml->Redirect('qtg_index.php');
}}

// --------
// HTML
// --------

$oHtml->scripts_end[] = '<script type="text/javascript">
document.getElementById("usr").focus();
if ( document.getElementById("usr").value.length>1 ) { document.getElementById("pwd").focus(); }
</script>
';

include 'qtg_adm_inc_hd.php';

echo '<div class="login">
<form method="post" action="',Href('qtg_adm_login.php'),'" onsubmit="return ValidateForm(this)">
<div style="margin:0 0 10px 0">
<p class="login"><label for="usr">',L('Username'),'</label> <input required type="text" id="usr" name="usr" size="15" maxlength="24" value="',$usr,'"/></p>
<p class="login"><label for="pwd">',L('Password'),'</label> <input required type="password" id="pwd" name="pwd" size="15" maxlength="24"/></p>
</div>
<p class="login"><input type="submit" name="ok" value="',Lh('Login'),'"/></p>
</form>
</div>
<br>',$qtg_back;

include 'qtg_inc_ft.php';