<?php
// QuickTalk Guestbook 4.0.3 build:20210106
session_start(); if ( empty($_SESSION['qtgAuth']) ) { header('Location: qtg_login.php'); die('Access denied.'); }

require 'qtg_init.php'; $qtg_skin='bin/css';

include 'bin/class/class.qt.table.php';
include getLangDir().'qtg_adm.php';
if ( $qtg_gkey ) include 'qtg_map_lib.php';

$oP->selfname=L('Messages');
$oP->selfurl='qtg_adm_msg.php';
$strOrder='issuedate';
$strDirec='desc';
$strWhere = '';
if ( $qtg_page_size<50 ) $qtg_page_size=$qtg_page_size*2;

// --------
// SUBMITTED (GET)
// --------

// Default filter
if ( empty($_GET['v']) ) $_GET['v']='*';

// Change status
if ( isset($_GET['id']) && isset($_GET['status']) )
{
  $oPost = new cPost();
  $oPost->id=cPost::UnHash($_GET['id']);
  $oPost->SetStatus($_GET['status']);
  memcacheFlush();
  // exit
  $_SESSION[QT.'pagedialog'] = (empty($error) ? 'O|'.$L['S_update'] : 'E|'.$error);
}

// Search filter
if ( !empty($_GET['q']) )
{
  $strWhere = $_GET['q'];
  // reformat if date
  if ( is_numeric(substr($strWhere,0,4)) && (int)(substr($strWhere,0,4))>2000 && substr($strWhere,4,1)==='-' ) $strWhere = str_replace('-','',$strWhere);
  $strWhere = QT_FILE ? $strWhere : ' AND (name LIKE "%'.$strWhere.'%" OR ip LIKE "%'.$strWhere.'%" OR issuedate LIKE "'.$strWhere.'%")';
}

// Change filter
if ( $_GET['v']==='y' || $_GET['v']==='n' ) $strWhere = QT_FILE ? '-'.$_GET['v'] : ' AND visible="'.strtoupper($_GET['v']).'"';

// --------
// SUBMITTED (POST, multiple rows)
// --------

if ( !empty($_POST['action']) ) {
if ( $_POST['action']==='hide' || $_POST['action']==='unhide' || $_POST['action']==='delete' ) {

  $ids = array();
  if ( !isset($_POST['ids']) )
  {
    // ask confirmation
    if ( isset($_POST['t1_cb']) ) $ids = is_array($_POST['t1_cb']) ? $_POST['t1_cb'] : explode(',',$_POST['t1_cb']);
    if ( count($ids)>0 )
    {
    	include 'qtg_adm_inc_hd.php';
      echo '<div class="inputbox">',PHP_EOL;
    	echo '<form method="post" action="'.$oP->selfurl.'">',PHP_EOL;
      echo '<p style="margin:0">',L('Confirm'),' ?</p>
      <p style="text-align:right">',ucfirst(L($_POST['action'])),' ('.L('Message',count($ids)).')</p>
      <p style="text-align:right">
      <input type="hidden" name="action" value="'.$_POST['action'].'" />
      <input type="hidden" name="ids" value="'.implode(',',$ids).'" />
      <a class="button" href="',$oP->selfurl,'">',L('Cancel'),'</a>
      <input type="submit" name="ok" value="'.($_POST['action']==='delete' ? Lh('Delete').' !' : Lh('Ok')).'" /></p>';
      echo '</form>',PHP_EOL;
    	echo '</div>',PHP_EOL;
    	include 'qtg_inc_ft.php';
      exit;
    }
    else
    {
      $warning = $L['E_nothing_selected'];
    }
  }
  else
  {
    // do action and clear cache
    $ids = explode(',',$_POST['ids']);
    foreach($ids as $id)
    {
      $oPost = new cPost();
      $oPost->id=cPost::Unhash($id);
      switch($_POST['action'])
      {
      case 'delete': $oPost->Delete(); $_SESSION[QT.'pagedialog'] = 'O|'.L('S_delete').'|'.count($ids); break;
      case 'hide': $oPost->SetStatus('N'); $_SESSION[QT.'pagedialog'] = 'O|'.L('S_update').'|'.count($ids); break;
      case 'unhide' : $oPost->SetStatus('Y'); $_SESSION[QT.'pagedialog'] = 'O|'.L('S_update').'|'.count($ids); break;
      }
    }
    memcacheFlush();
  }

}}

// --------
// COUNT
// --------

// Count all (no where-clause)
$bSubset = false;
$countAll = memcacheGet(QT.'-countAll');
if ( $countAll===false ) { $countAll=CountMessages($oDB); $bSubset=true; memcacheSet(QT.'-countAll',$countAll); }
if ( $countAll>0 )
{
  $countU = memcacheGet(QT.'-countU');
  if ( $countU===false ) { $countU=CountMessages($oDB,'u',$bSubset); memcacheSet(QT.'-countU',$countU); }
}
if ( empty($countU) ) $countU=0;

// Count All (if where clause): if search definied, count again
$intCount = $countAll;
if ( !empty($strWhere) )
{
  if ( QT_FILE )
  {
    $intCount = $oDB->FilesCount($strWhere);
  }
  else
  {
    $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0'.$strWhere );
    if ($row = $oDB->Getrow()) $intCount = (int)$row['countid'];
  }
}

// --------
// HTML START
// --------

$oHtml->scripts[] = '<script type="text/javascript" src="bin/js/qtg_table.js"></script>
<script type="text/javascript">
function datasetcontrol_click(checkboxname,action)
{
  var checkboxes = document.getElementsByName(checkboxname);
  var n = 0;
  for (var i=0; i<checkboxes.length; i++) if ( checkboxes[i].checked ) n++;
  if ( n>0 )
  {
  document.getElementById("form_messages_action").value=action;
  document.getElementById("form_messages").submit();
  return;
  }
  else
  {
  alert(qtHtmldecode("'.L('No_selected_row').'"));
  return false;
  }
}

function doselect(checkboxname,action)
{
  var checkboxes = document.getElementsByName(checkboxname);
  var i = checkboxes.length - 1;
  do
  {
  switch(action)
  {
  case "none":    checkboxes[i].checked=false; break;
  case "hidden":  checkboxes[i].checked=(checkboxes[i].id.substring(checkboxes[i].id.length-2)!="_Y"); break;
  case "visible": checkboxes[i].checked=(checkboxes[i].id.substring(checkboxes[i].id.length-2)=="_Y"); break;
  default:        checkboxes[i].checked=true; break;
  }
  qtHighlight("tr_"+checkboxes[i].id,checkboxes[i].checked);
  }
  while (i--);
  qtCheckboxOne(checkboxname,"t1_cb");
}
</script>
';

$oHtml->scripts_jq[] = '$(document).ready(function() {

  $("#t1 td:not(.tdcheckbox,.tdaction)").click(function() { qtCheckboxToggle(this.parentNode.id.substring(3)); });

  // CHECKBOX ALL ROWS

  $("input[id=\'t1_cb\']").click(function() { qtCheckboxAll("t1_cb","t1_cb[]",true); });

  // SHIFT-CLICK CHECKBOX

  var lastChecked1 = null;
  var lastChecked2 = null;
  $("input[name=\'t1_cb[]\']").click(function(event) {
    if(!lastChecked1)
    {
      lastChecked1 = this;
      qtHighlight("tr_"+this.id,this.checked);
      return;
    }
    if(event.shiftKey)
    {
      var start = $("input[name=\'t1_cb[]\']").index(this);
      var end = $("input[name=\'t1_cb[]\']").index(lastChecked1);
      for(var i=Math.min(start,end);i<=Math.max(start,end);i++)
      {
      $("input[name=\'t1_cb[]\']")[i].checked = lastChecked1.checked;
      qtHighlight("tr_"+$("input[name=\'t1_cb[]\']")[i].id,lastChecked1.checked);
      }
    }
    lastChecked1 = this;
    qtHighlight("tr_"+this.id,this.checked);
  });
});
';

// Subtitle
$subtitle = L('message',$intCount).($intCount<$countAll ? ' ('.L('from').' '.$countAll.')' : '').' | '.L('Show').' '.L('status').': '.PHP_EOL;
if ( $_GET['v']!=='*' || !empty($_GET['q']) ) $subtitle .= '<a href="'.$oP->selfurl.'">'.L('all').'</a> ';
if ( $_GET['v']!=='y' ) $subtitle .= '<a href="'.$oP->selfurl.'?v=y">'.L('visibles').'</a> ';
if ( $_GET['v']!=='n' ) $subtitle .= '<a href="'.$oP->selfurl.'?v=n">'.L('hiddens').'</a> ';
if ( $countU>0 ) $subtitle .= ' | <i class="qtg-icon icon-attention"></i> <a href="qtg_adm_msg_u.php">'.L('To_be_reviewed').' ('.$countU.')</a>';
if ( $qtg_reviewer && $countU==0 ) $subtitle .= ' | <span class="disabled">'.L('To_be_reviewed').' ('.$countU.')</span>';

include 'qtg_adm_inc_hd.php';

// Table 1

// Search form
$placeholder = (QT_FILE ? '' : L('Name').', ').L('date').' '.L('or').' IP';
echo '<div class="right">
<form id="form_filter" method="get" action="',$oP->selfurl,'">
<input type="text" name="q" value="',(empty($_GET['q']) ? '' : $_GET['q']),'" placeholder="'.$placeholder.'"/>
',(empty($_GET['q']) ? '' : '<a class="button" href="'.$oP->selfurl.'" title="'.L('Cancel').'"><i class="qtg-icon icon-cancel"></i></a>'),'
<button type="submit" title="',L('Search'),'"><i class="qtg-icon icon-search"></i></button>
</form>
<a class="button" href="qtg_adm_medit.php">',L('Bulk_edition'),'...</a>
</div>';

if ( isset($_GET['page']) ) { $limit=($_GET['page']-1)*$qtg_page_size; $page=intval($_GET['page']); } else { $limit=0; $page=1; }

$table = new TabTable('id=t1|class=messages', $intCount, 2);

// ---------------
if ( $intCount>0 ) {
// ---------------

// pager

$strPager = MakePager($oP->selfurl,$intCount,$qtg_page_size,$page);
if ( $strPager!='' ) $strPager = $L['Page'].$strPager;

// data command

$strDataCommand = '<a class="datasetcontrol" onclick="datasetcontrol_click(\'t1_cb[]\',\'unhide\'); return false;" href="javascript:void(0);">'.L('Unhide').'</a> &middot;
<a class="datasetcontrol" onclick="datasetcontrol_click(\'t1_cb[]\',\'hide\'); return false;" href="javascript:void(0);">'.L('Hide').'</a> &middot;
<a class="datasetcontrol" onclick="datasetcontrol_click(\'t1_cb[]\',\'delete\'); return false;" href="javascript:void(0);">'.L('Delete').'</a> |
'.L('select').':
<a class="datasetcontrol" onclick="doselect(\'t1_cb[]\',\'hidden\'); return false;" href="javascript:void(0);">'.L('hidden').'</a>
<a class="datasetcontrol" onclick="doselect(\'t1_cb[]\',\'visible\'); return false;" href="javascript:void(0);">'.L('visible').'</a>
<a class="datasetcontrol" onclick="doselect(\'t1_cb[]\',\'none\'); return false;" href="javascript:void(0);">'.L('none').'</a>'.PHP_EOL;

// query

if ( QT_FILE )
{
  $oDB->GetFiles($strWhere);
  rsort($oDB->arrFiles);
  if ( count($oDB->arrFiles)>$qtg_page_size ) $oDB->arrFiles = array_slice($oDB->arrFiles, $limit, $qtg_page_size-1);
  $oDB->curFiles=0;
}
else
{
  $oDB->Query( LimitSQL('* FROM '.TABMESSAGE.' WHERE id>=0'.$strWhere,'issuedate DESC',$limit,$qtg_page_size) );
}

echo '
<form id="form_messages" method="post" action="',$oP->selfurl,'"><input type="hidden" id="form_messages_action" name="action" value=""/>
<table class="pager_zt"><tr>',($intCount<2 ? '' : '<td class="pager_zt"><img src="bin/css/selection_up.gif" style="width:10px;height:10px;vertical-align:bottom;margin:0 10px 0 10px" alt="|" />'.$strDataCommand.'</td>'),'<td class="pager_zt right">',$strPager,'</td></tr></table>
';

  // === TABLE DEFINITION ===
  $table->activecol = $strOrder;
  $table->activelink = '<a  href="'.$oP->selfurl.'?page=1&order='.$strOrder.'&dir='.($strDirec=='asc' ? 'desc' : 'asc').'">%s</a> <img class="i_sort" src="bin/css/sort_'.$strDirec.'.gif" alt="+"/>';
  $table->arrTh['checkbox'] = new TabHead(($table->countDataRows<2 ? '&nbsp;' : '<input type="checkbox" name="t1_cb_all" id="t1_cb" />'));
  $table->arrTh['issuedate']= new TabHead(L('Date'),'class=thissuedate');
  $table->arrTh['source']  = new TabHead(L('Source'),'class=thsource');
  $table->arrTh['message']  = new TabHead($L['Message'],'class=thmessage');
  if ( $qtg_gkey ) $table->arrTh['coord'] = new TabHead('&nbsp;','class=thcoord');
  $table->arrTh['action']   = new TabHead('Action','class=thaction');
  // create column data (from headers identifiers) and add class to all
  foreach($table->arrTh as $key=>$th)
  {
    $table->arrTd[$key] = new TabData();
  }
  $table->arrTd['checkbox']->add('class','tdcheckbox');
  $table->arrTd['issuedate']->add('class','tdissuedate');
  $table->arrTd['source']->add('class','tdsource');
  $table->arrTd['message']->add('class','tdmessage');
  if ( $qtg_gkey ) $table->arrTd['coord']->add('class','tdcoord');
  $table->arrTd['action']->add('class','tdaction');

  // === TABLE START DISPLAY ===

  echo PHP_EOL;
  echo $table->start().PHP_EOL;
  echo '<thead>'.PHP_EOL;
  echo $table->getTHrow().PHP_EOL;
  echo '</thead>'.PHP_EOL;
  echo '<tbody>'.PHP_EOL;

  $strAlt='r1';
  while($row=$oDB->Getrow())
  {
    $oPost = new cPost($row);
    if ( !$row ) break;
    $id = cPost::Hash($oPost->id); // use hashed
    $table->row = new TabItem('tr', 'id=tr_t1_cb'.$id.'_'.$oPost->visible.'|class=message '.$strAlt.' rowlight'.($oPost->visible=='Y' ? '' : ' hidden')); // force reset in the loop
    $table->arrTd['checkbox']->content = ($table->countDataRows<2 ? '&nbsp;' : '<input type="checkbox" name="t1_cb[]" id="t1_cb'.$id.'_'.$oPost->visible.'" value="'.$id.'" />');
    $table->arrTd['issuedate']->content= (empty($oPost->issuedate) ? '&nbsp;' : QTdatestr($oPost->issuedate,'Y-m-d','$'));
    $table->arrTd['source']->content = $oPost->name.($oPost->userage>0 || !empty($oPost->postfrom) ? '<br>' : '').($oPost->userage>0 ? '('.$oPost->userage.') ' : '').(empty($oPost->postfrom) ? '' : $oPost->postfrom).(empty($oPost->ip) ? '' : '<br>ip '.$oPost->ip);
    $table->arrTd['message']->content = ($oPost->visible==='U' ? '<i class="qtg-icon icon-attention"></i> ' : '').RenderMsg($oPost->message,180,$qtg_tags,'...',$qtg_skin,' ');
    if ( $qtg_gkey )
    {
    $table->arrTd['coord']->content = ($oPost->hasCoord() ? ' <i class="qtg-icon icon-location" title="lat,long: '.QTdd2dms((float)$oPost->y).','.QTdd2dms((float)$oPost->x).'"></i>' : ' <i class="qtg-icon icon-location" title="no coordinates" style="color: rgba(0, 0, 0, 0.25)"></i>');
    }
    $table->arrTd['action']->content = '<a href="qtg_msg_edit.php?adm&id='.$id.'&page='.$page.'">'.$L['Edit'].'</a> &middot; ';
    $table->arrTd['action']->content .= '<a href="qtg_msg_del.php?adm&id='.$id.'&page='.$page.'">'.$L['Delete'].'</a> &middot; ';
    if ( $oPost->visible=='Y' )
    {
    $table->arrTd['action']->content .= '<a href="'.$oP->selfurl.'?id='.$id.'&status=N&page='.$page.'">'.$L['Hide'].'</a>';
    }
    else
    {
    $table->arrTd['action']->content  .= '<a href="'.$oP->selfurl.'?id='.$id.'&status=Y&page='.$page.'">'.$L['Unhide'].'</a>';
    }
    if ( !empty($oPost->useremail) ) $table->arrTd['message']->content .= ' <a href="mailto:'.$oPost->useremail.'" title="'.$oPost->useremail.'"><i class="qtg-icon icon-mail-alt" title="'.$oPost->useremail.'"></i></a>';
    echo $table->getTDrow();
    if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }
  }

  // === TABLE END DISPLAY ===

  echo '</tbody>',PHP_EOL;
  echo '</table>',PHP_EOL;

  echo '<table class="pager_zb"><tr>',($intCount<5 ? '' : '<td class="pager_zb"><img src="bin/css/selection_down.gif" style="width:10px;height:10px;vertical-align:top;margin:0 10px 0 10px" alt="|" />'.$strDataCommand.'</td>'),'<td class="pager_zb right">',$strPager,'</td></tr></table>',PHP_EOL;
  echo '</form>',PHP_EOL;

}
else
{
  if ( !empty($strPager) ) echo '<table class="hidden"><tr><td class="pager_zt right">',$strPager,'</td></tr></table>',PHP_EOL;
  $table->arrTh[] = new TabHead('&nbsp;');
  echo $table->getEmptyTable('<p style="margin-left:10px;margin-right:10px">'.L('None').'...</p>', true, 'class=r1');
}

// --------
// HTML END
// --------

if ( QT_FILE ) echo '<p class="disabled" style="margin:15px 0 0 0">File repository: ',$oDB->root,'</p>';

include 'qtg_inc_ft.php';