<?php
// QuickTalk Guestbook 4.0.3 build:20220105
session_start(); if ( empty($_SESSION['qtgAuth']) ) { header('Location: qtg_login.php'); die('Access denied.'); }

require 'qtg_init.php'; $qtg_skin='bin/css';

include getLangDir().'qtg_adm.php';

$oP->selfname=$L['Security'];
$oP->selfurl='qtg_adm_secu.php';
$arrYN = array($L['No'],$L['Yes']);

if ( !isset($qtg_captcha2pk) ) $qtg_captcha2pk=''; //public key (site key)
if ( !isset($qtg_captcha2sk) ) $qtg_captcha2sk=''; //secret key (validation api access key)
if ( !isset($qtg_captcha3pk) ) $qtg_captcha3pk=''; //public key (site key)
if ( !isset($qtg_captcha3sk) ) $qtg_captcha3sk=''; //secret key (validation api access key)

// FUNCTION
function QTencrypt(string $key=APP, string $str='install')
{
  $key = hash('sha256', $key);
  $iv = substr(hash('sha256','5fgf5HJ5g27'), 0, 16); // sha256 is hash_hmac_algo
  $output = openssl_encrypt($str, 'AES-256-CBC', $key, 0, $iv);
  return base64_encode($output);
  // no need to decrypt (just check that encrypted folder exists)
  // to decrypt use: return openssl_decrypt(base64_decode($str), 'AES-256-CBC', $key, 0, $iv);
}

// --------
// SUBMITTED
// --------

if ( isset($_GET['cmd']) && $_GET['cmd']=='decrypt' && !empty($_GET['file']) )
{
  if ( is_dir($_GET['file']) && rename($_GET['file'],'install') ) {
    $_SESSION[QT.'pagedialog'] = 'O|Install decrypted';
  } else {
    $_SESSION[QT.'pagedialog'] = 'E|Unable to rename folder install !';
  }
}

// Special remove all status U
if ( isset($_GET['rrs']) && !empty($countU) )
{
  cPost::ChangeAllUStatus();
  memcacheFlush();
  $_SESSION[QT.'pagedialog'] = (empty($error) ? 'O|'.L('S_update') : 'E|'.$error);
}

if ( isset($_POST['ok']) )
{
  // Force re-count if security changes
  memcacheUnset(QT.'-countU');
  // check notify (can be empty)
  if ( empty($error) )
  {
    $str=trim($_POST['notify']); if ( get_magic_quotes_gpc() ) $str=stripslashes($str);
    if ( empty($str) )
    {
    $qtg_notify='';
    }
    else
    {
    if ( QTismail($str) ) { $qtg_notify=$str; } else { $error='E-mail ['.$str.'] '.L('E_invalid'); }
    }
  }
  // check antispam method
  $qtg_antispam = $_POST['antispam'];
  if ( $qtg_antispam=='reCAPTCHAv2' )
  {
    if ( empty($_POST['captcha2pk']) || empty($_POST['captcha2sk']) ) $oP->err = 'reCAPTCHA keys are missing';
    if ( !empty($_POST['captcha2pk']) ) $qtg_captcha2pk = $_POST['captcha2pk'];
    if ( !empty($_POST['captcha2sk']) ) $qtg_captcha2sk = $_POST['captcha2sk'];
  }
  if ( $qtg_antispam=='reCAPTCHAv3' )
  {
    if ( empty($_POST['captcha3pk']) || empty($_POST['captcha3sk']) ) $oP->err = 'reCAPTCHA keys are missing';
    if ( !empty($_POST['captcha3pk']) ) $qtg_captcha2pk = $_POST['captcha3pk'];
    if ( !empty($_POST['captcha3sk']) ) $qtg_captcha2sk = $_POST['captcha3sk'];
  }
  // check msg max size
  $str = trim($_POST['max_size']);
  if ( !is_numeric($str) ) $error=$L['Msg_max_size'].' ['.$str.'] '.L('E_invalid').' (500-50000)';
  if ( empty($error) ) { if ( !QTisbetween($str,500,5000) ) $error=$L['Msg_max_size'].' ['.$str.'] '.L('E_invalid').' (500-50000)'; }
  if ( empty($error) ) $qtg_max_size = intval($str);
  // check day
  $str = trim($_POST['max_day']);
  if ( !is_numeric($str) ) $error=$L['Flood_max_day'].' ['.$str.'] '.L('E_invalid').' (1-100)';
  if ( empty($error) ) { if ( !QTisbetween($str,1,100) ) $error=$L['Flood_max_day'].' ['.$str.'] '.L('E_invalid').' (1-100)'; }
  if ( empty($error) ) $qtg_max_day = intval($str);
  // use reviewer
  $qtg_reviewer = $_POST['reviewer']==='1';
  // check ip
  $qtg_checkip = $_POST['checkip']==='1';
  $qtg_checkip_list = ''; if ( isset($_POST['iplist']) ) $qtg_checkip_list = trim($_POST['iplist']);
  $qtg_checkip_list = str_replace(array("\r\n","\n",",",";"),' ',$qtg_checkip_list);
  // check each ip
  if ( !empty($qtg_checkip_list) )
  {
    $arrIp = explode(' ',$qtg_checkip_list);
    foreach($arrIp as $strIp)
    {
      if ( !preg_match('/^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\..+$/',$strIp) ) $error='IP '.L('E_invalid');
    }
  }
  // check meaning/langue/url
  $qtg_meaning = isset($_POST['meaning']) && $_POST['meaning']==='1';
  $qtg_checklang = isset($_POST['checklang']) && $_POST['checklang']==='1';
  $qtg_checkurl = isset($_POST['checkurl']) && $_POST['checkurl']==='1';
  // save result
  if ( empty($error) )
  {
    $file='config/config_stop.php';
    if (!is_writable($file)) $error = 'Impossible to write into the file ['.$file.'].';
  }
  if ( empty($error) )
  {
    // check string variables to remove quotes
    foreach (array('qtg_notify','qtg_checkip_list') as $strVar)
    {
      if ( isset($$strVar) ) {
      if ( strstr($$strVar,"'") ) {
        $$strVar = str_replace("'",'&#039;',$$strVar);
      }}
    }

if ( $qtg_checkurl && $qtg_bbc_url ) $qtg_checkurl=false; // checkurl disabled when bbc url is allowed
$str = '<?php
$qtg_reviewer = '.($qtg_reviewer ? 'true' : 'false').';
$qtg_notify = "'.$qtg_notify.'";
$qtg_max_size = '.$qtg_max_size.';
$qtg_max_day = '.$qtg_max_day.';
$qtg_antispam = "'.$qtg_antispam.'";
$qtg_checkip = '.($qtg_checkip ? 'true' : 'false').';
$qtg_checkip_list = "'.$qtg_checkip_list.'";
$qtg_meaning = '.($qtg_meaning ? 'true' : 'false').';
$qtg_checklang = '.($qtg_checklang ? 'true' : 'false').';
$qtg_checkurl = '.($qtg_checkurl ? 'true' : 'false').';
$qtg_captcha2pk = "'.$qtg_captcha2pk.'";
$qtg_captcha2sk = "'.$qtg_captcha2sk.'";
$qtg_captcha3pk = "'.$qtg_captcha3pk.'";
$qtg_captcha3sk = "'.$qtg_captcha3sk.'";';
  $error = saveToFile($file,$str);
  }
  // exit
  $_SESSION[QT.'pagedialog'] = (empty($error) ? 'O|'.$L['S_save'] : 'E|'.$error);
}

// --------
// HTML START
// --------

if ( $qtg_checkurl && $qtg_bbc_url ) $qtg_checkurl=false; // checkurl disabled when bbc url is allowed

// INITIALIZE count U (even if $qtg_reviewer=false)
$countU = memcacheGet(QT.'-countU'); if ( $countU===false ) { $countU=CountMessages($oDB,'u'); memcacheSet(QT.'-countU',$countU); }
if ( empty($countU) ) $countU=0;
if ( $countU>0 ) $subtitle='<i class="qtg-icon icon-attention"></i> <a href="qtg_adm_msg_u.php">'.L('To_be_reviewed').' ('.$countU.')</a>';

include 'qtg_adm_inc_hd.php';


// configuration changed
if ( $countU>0 && !$qtg_reviewer )
{
  echo '<p style="margin:0 0 15px 0">',L('HRemove_old_u'),'<br><a href="qtg_adm_secu.php?rrs">',L('Remove_old_u'),' (',$countU,')</a></p>';
}

echo '<form method="post" action="',$oP->selfurl,'">
';

echo '<div class="options">',L('Input_control'),'</div>
<table width="100%" class="option">
<tr>
<th style="width:180px;"><label for="checklang">',L('Use_reviewer'),'</label></th>
<td style="width:220px;"><select id="reviewer" name="reviewer" onchange="bEdited=true;">',QTasTag($arrYN,(int)$qtg_reviewer),'</select></td>
<td class="help">',L('HUse_reviewer'),'</td>
</tr>
<tr>
<th><label for="antispam">',L('Check_human'),'</label></th>
<td>
<select id="antispam" name="antispam" onchange="antispam_changed(this.value);bEdited=true;">
<optgroup label="',L('Internal'),'">
<option value="none"',($qtg_antispam==='none' || $qtg_antispam==0 ? QSEL : ''),'>',L('None'),'</option>
<option value="text"',($qtg_antispam==='text' || $qtg_antispam==1 ? QSEL : ''),'>',L('Text_code'),'</option>
<option value="image"',($qtg_antispam==='image' || $qtg_antispam==2 ? QSEL : ''),'>',L('Image_code'),'</option>
</optgroup>
<optgroup label="',L('Online_service'),'">
<option value="reCAPTCHAv2"',($qtg_antispam==='reCAPTCHAv2' ? QSEL : ''),'>reCAPTCHA v2</option>
<option value="reCAPTCHAv3"',($qtg_antispam==='reCAPTCHAv3' ? QSEL : ''),'>reCAPTCHA v3</option>
</optgroup>
</select>
<td class="help" rowspan="2">',L('HCheck_human'),'</td>
</tr>
';
echo '<tr id="reCPATCHAv2keys" style="display:',($qtg_antispam=='reCAPTCHAv2' ? 'table-row' : 'none'),'">
<th>reCAPTCHA api keys</td>
<td>
<input type="text" id="captcha2pk" name="captcha2pk" size="24" maxlength="255" value="',$qtg_captcha2pk,'" onchange="bEdited=true;" placeholder="reCAPTCHA v2 site key" title="reCAPTCHA v2 site key"/>
<input type="text" id="captcha2sk" name="captcha2sk" size="24" maxlength="255" value="',$qtg_captcha2sk,'" onchange="bEdited=true;" placeholder="reCAPTCHA v2 secret key" title="reCAPTCHA v2 secret key"/>
</td>
</tr>
';
echo '<tr id="reCPATCHAv3keys" style="display:',($qtg_antispam=='reCAPTCHAv3' ? 'table-row' : 'none'),'">
<th>reCAPTCHA api keys</td>
<td>
<input type="text" id="captcha3pk" name="captcha3pk" size="24" maxlength="255" value="',$qtg_captcha3pk,'" onchange="bEdited=true;" placeholder="reCAPTCHA v3 site key" title="reCAPTCHA v3 site key"/>
<input type="text" id="captcha3sk" name="captcha3sk" size="24" maxlength="255" value="',$qtg_captcha3sk,'" onchange="bEdited=true;" placeholder="reCAPTCHA v3 secret key" title="reCAPTCHA v3 secret key"/>
</td>
</tr>
</table>
';
echo '<div class="options">',L('Security_settings'),'</div>
<table width="100%" class="option">
<tr>
<th style="width:180px;"><label for="max_size">',L('Msg_max_size'),'</label></th>
<td style="width:220px;"><input type="text" required id="max_size" name="max_size" size="5" maxlength="5" value="',$qtg_max_size,'" onchange="bEdited=true;" pattern="^[1-9][0-9]{2,4}$"> ',L('Characters'),'</td>
<td class="help">',L('HMsg_max_size'),'</td>
</tr>
<tr>
<th><label for="max_day">',L('Flood_max_day'),'</label></th>
<td><input type="text" required id="max_day" name="max_day" size="3" maxlength="3" pattern="([1-9]|^[1-9][0-9]{1,2}$)$" value="',$qtg_max_day,'" onchange="bEdited=true;"/> / ',L('User'),'</td>
<td class="help">',L('HFlood_max_day'),'</td>
</tr>
<tr>
<th><label for="notify">',L('Activity_notify'),'</label></th>
<td><input type="email" name="notify" id="notify" size="24" maxlength="255" value="',$qtg_notify,'" onchange="bEdited=true;"/></td>
<td class="help">',L('HActivity_notify'),'</td>
</tr>
</table>
';

echo '<div class="options">',L('Reject_settings'),'</div>
<table width="100%" class="option">
<tr>
<th style="width:180px;"><label for="meaning">',L('Check_meaning'),'</label></th>
<td style="width:220px;">
<select id="meaning" name="meaning" onchange="bEdited=true;">',QTasTag($arrYN,(int)$qtg_meaning),'</select>
</td>
<td class="help">',L('HCheck_meaning'),'</td>
</tr>
<tr>
<th style="width:180px;"><label for="checklang">',L('Check_lang'),'</label></th>
<td style="width:100px;">
<select id="checklang" name="checklang" onchange="bEdited=true;">',QTasTag($arrYN,(int)$qtg_checklang),'</select>
</td>
<td class="help">',L('HCheck_lang'),'</td>
</tr>
<tr>
<tr>
<th style="width:180px;"><label for="checkurl">',L('Check_url'),'</label></th>
<td style="width:220px;">
<select id="checkurl" name="checkurl" onchange="bEdited=true;"'.($qtg_bbc_url ? ' disabled' : '').'>',QTasTag($arrYN,(int)$qtg_checkurl),'</select>
</td>
<td class="help">',L('HCheck_url'),'</td>
</tr>
<th><label for="checkip">',L('Check_ip'),'</label></th>
<td>
<select id="checkip" name="checkip" onchange="bEdited=true;">',QTasTag($arrYN,(int)$qtg_checkip),'</select><br>
<textarea class="small" name="iplist" id="iplist" cols="29" rows="3">',$qtg_checkip_list.'</textarea>
<td class="help">',L('HCheck_ip'),'</td>
</tr>
</table>
';
echo '<p style="color:#888"><i class="qtg-icon icon-info-circled"></i>',L('Reject_settings'),': '.L('Not_while_admin').'</p>';
echo '<p style="text-align:center"><input type="submit" name="ok" value="',Lh('Save'),'"/></p>
</form>
<script type="text/javascript">
function antispam_changed(str) {
  document.getElementById("reCPATCHAv2keys").style.display=(str=="reCAPTCHAv2" ? "table-row" : "none");
  document.getElementById("reCPATCHAv3keys").style.display=(str=="reCAPTCHAv3" ? "table-row" : "none");
}
</script>
';

if ( is_dir('install') ) {
  echo '<p class="right" style="margin:0"><i class="qtg-icon icon-attention" style="font-size:1.2rem;color:red"></i> Install folder is accessible: <a href="install/qtg_setup_9.php?lang='.$_SESSION[QT]['language'].'">'.L('Change').'...</a></p>';
} else {
  $file = QTencrypt(); if ( is_dir($file) ) echo '<p class="right" style="margin:0"><a href="'.APP.'_adm_secu.php?cmd=decrypt&file='.$file.'">decrypt install folder</a></p>';
}
// --------
// HTML END
// --------

include 'qtg_inc_ft.php';