<?php
// QuickTalk Guestbook 4.0.3 build:20210106
session_start(); if ( empty($_SESSION['qtgAuth']) ) { header('Location: qtg_login.php'); die('Access denied.'); }

require 'qtg_init.php';

if ( $_SESSION['qtgAuth']!==QT ) { header('Location: qtg_login.php'); die('Access denied.'); } // client use a session of an other quicktalk installation on the same server.

$gui_skin = str_replace('skin/','',$qtg_skin); //conserve the skin name
$qtg_skin = 'bin/css'; //override the skin in this page

include getLangDir().'qtg_adm.php';
$oP->selfname=L('Site');
$oP->selfurl='qtg_adm_site.php';
$arrYN = array(L('No'),L('Yes'));

// INITIALIZE count U (even if $qtg_reviewer=false)
$countU = memcacheGet(QT.'-countU'); if ( $countU===false ) { $countU=CountMessages($oDB,'u'); memcacheSet(QT.'-countU',$countU); }
if ( empty($countU) ) $countU=0;
if ( $countU>0 ) $subtitle='<i class="qtg-icon icon-attention"></i> <a href="qtg_adm_msg_u.php">'.L('To_be_reviewed').' ('.$countU.')</a>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check guestbook status
  $qtg_actif = ($_POST['status']==='1');

  // site type
  $qtg_type = $_POST['site_type'];

  // check sitename
  $str = QTdb(trim($_POST['title'])); // encode
  if ( !empty($str) ) { $qtg_title = $str; } else { $error=L('Site_name').' '.L('E_invalid'); }

  // check siteurl (can be empty)
  if ( empty($error) )
  {
    $str = trim($_POST['home']); if ( $str=='http://' || $str=='https://' ) $str='';
    if ( empty($str) )
    {
      $qtg_home='';
    }
    else
    {
      if ( substr($str,-1,1)=='/' ) $str=substr($str,0,-1);
      if ( !preg_match('/^(http:\/\/|https:\/\/)/',$str) ) $error=$L['Home_page'].' ['.$str.'] '.L('E_invalid').' (http://, https://)';
      if ( empty($error) ) $qtg_home=$str;
    }
  }

  // check admin email
  if ( empty($error) )
  {
    $str = trim($_POST['email']); if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
    if ( QTismail($str) ) { $qtg_email=$str; } else { $error=$L['Home_email'].' ['.$str.'] '.L('E_invalid'); }
  }

  // save result
  if ( empty($error) )
  {
    $file='config/config_site.php';
    if (!is_writable($file)) $error = 'Impossible to write into the file ['.$file.'].';
  }
  if ( empty($error) )
  {
    // check string variables to remove quotes
    foreach (array('qtg_language','gui_skin','qtg_formatdate','qtg_formattime','qtg_title','qtg_home','qtg_email','qtg_pagewidth','qtg_welcome') as $strVar)
    {
      if ( isset($$strVar) ) {
      if ( strstr($$strVar,"'") ) {
        $$strVar = str_replace("'",'&#039;',$$strVar);
      }}
    }
$str = '<?php
$qtg_actif = '.($qtg_actif ? 'true' : 'false').';
$qtg_type = "'.$qtg_type.'";
$qtg_language = "'.$qtg_language.'";
$qtg_menulang = '.($qtg_menulang ? 'true' : 'false').';
$qtg_skin = "'.$gui_skin.'";
$qtg_formatdate = "'.$qtg_formatdate.'";
$qtg_formattime = "'.$qtg_formattime.'";
$qtg_banner = '.($qtg_banner ? 'true' : 'false').';
$qtg_title = "'.$qtg_title.'";
$qtg_home = "'.$qtg_home.'";
$qtg_email = "'.$qtg_email.'";
$qtg_show_size = '.(empty($qtg_show_size) ? 200 : $qtg_show_size).';
$qtg_page_size = '.(empty($qtg_page_size) ? 10 : $qtg_page_size).';
$qtg_use_age = '.($qtg_use_age ? 'true' : 'false').';
$qtg_use_email = '.($qtg_use_email ? 'true' : 'false').';
$qtg_use_from = '.($qtg_use_from ? 'true' : 'false').';
$qtg_use_from_type = '.(empty($qtg_use_from_type) ? 0 : $qtg_use_from_type).';
$qtg_column_default = '.($qtg_column_default ? 'true' : 'false').';
$qtg_column_change = '.($qtg_column_change ? 'true' : 'false').';
$qtg_separateform = '.($qtg_separateform ? 'true' : 'false').';
$qtg_bbc_bold = '.($qtg_bbc_bold ? 'true' : 'false').';
$qtg_bbc_italic = '.($qtg_bbc_italic ? 'true' : 'false').';
$qtg_bbc_underline = '.($qtg_bbc_underline ? 'true' : 'false').';
$qtg_bbc_url = '.($qtg_bbc_url ? 'true' : 'false').';
$qtg_bbc_smiley = '.($qtg_bbc_smiley ? 'true' : 'false').';
';
  $error = saveToFile($file,$str);
  }

  // exit
  $_SESSION[QT.'pagedialog'] = (empty($error) ? 'O|'.$L['S_save'] : 'E|'.$error);
}

// --------
// HTML START
// --------

include 'qtg_adm_inc_hd.php';

echo '<div class="options">',L('Status'),'</div>
<form method="post" action="',$oP->selfurl,'">
<table width="100%" class="option">
<tr>
<th style="width:180px;"><span class="texthead"><label for="status">',L('Guestbook_status'),'</label></th>
<td style="width:220px;">
<span style="display:inline-block;width:15px;background-color:',($qtg_actif ? 'green' : 'red'),';border-radius:3px">&nbsp;</span>
&nbsp;<select id="status" name="status" onchange="bEdited=true;">',QTasTag(array(L('Closed'),L('Actif')),(int)$qtg_actif),'</select>
</td>
<td class="help">',L('HGuestbook_status'),'</td>
</tr>
<tr>
<th style="width:180px;"><span class="texthead"><label for="site_type">',L('Site_type'),'</label></th>
<td style="width:240px">
<select id="site_type" name="site_type" onchange="bEdited=true;">
<option value="1"',($qtg_type==1 ? QSEL : ''),'>',$L['Site_type_1'],'</option>
<option value="2"',($qtg_type==2 ? QSEL : ''),'>',$L['Site_type_2'],'</option>
<option value="3"',($qtg_type==3 ? QSEL : ''),'>',$L['Site_type_3'],'</option>
</select></td>
<td class="help">',$L['HSite_type'],'</td>
</tr>
<tr>
<th style="width:180px;"><span class="texthead">',L('Version'),'</span></th>
<td style="width:220px;">',VERSION,' ',BUILD,'</td>
<td class="help">
';
if ( file_exists('qtg_about.txt') ) echo '<a href="qtg_adm_txt.php?file=qtg_about.txt&rows=32&v='.urlencode(VERSION).'">release notes</a>';
if ( file_exists('bin/phpinfo.php') ) echo ' &middot; <a target="_blank" href="bin/phpinfo.php">php info</a>';
echo '
</td>
</tr>
</table>
';

echo '<div class="options">',L('Site_settings'),'</div>
<table width="100%" class="option">
<tr>
<th style="width:180px;"><span class="texthead"><label for="title">',L('Site_title'),'</label></th>
<td style="width:240px"><input required type="text" id="title" name="title" size="24" maxlength="255" value="',$qtg_title,'" onchange="bEdited=true;"/></td>
<td class="help">',L('HSite_title'),'</td>
</tr>
<tr>
<th><span class="texthead"><label for="home">',$L['Home_page'],'</label></th>
<td><input type="text" id="home" name="home" pattern="(http://|https://).*" size="24" maxlength="255" value="',(empty($qtg_home) ? 'http://' : $qtg_home),'" onchange="bEdited=true;"/></td>
<td class="help">',$L['HHome_page'],'</td>
</tr>
<tr>
<th><span class="texthead"><label for="email">',$L['Home_email'],'</label></th>
<td><input type="email" id="email" name="email" size="24" maxlength="100" value="',$qtg_email,'" onchange="bEdited=true;" required/></td>
<td class="help">',$L['HHome_email'],'</td>
</tr>
</table>
';

echo '<p style="text-align:center"><input type="submit" name="ok" value="',Lh('Save'),'"/></p>
</form>
';

echo '<br>
<h1>',L('Messages'),' "',L('Welcome'),'" ',L('and'),' "',L('Wait'),'"','</h1>
';

foreach(['welcome-','wait-'] as $edit)
{
  $arrFiles = array();
  $arrTexts = array();
  foreach(array_keys(LANGUAGES) as $key)
  {
    $arrFiles[$key] = $edit.$key.'.txt';
    $arrTexts[$key] = 'file not found config/'.$arrFiles[$key];
    if ( file_exists('config/'.$arrFiles[$key]) )
    {
      $str = file_get_contents('config/'.$arrFiles[$key], FALSE, NULL, 0, 204);
      if ( strlen($str)>200 ) $str = substr($str,0,00).' ...';
      $arrTexts[$key] = str_replace(array('<','>'), array('&lt;','&gt;'), $str);
      htmlspecialchars($str);
    }
  }
  echo '<div class="options">',L('Edit'),'</div>
  <table width="100%" class="option">
  ';
  foreach(LANGUAGES as $key=>$str)
  {
    $str = explode(' ',$str,2); $str = isset($str[1]) ? $str[1] : $str[0];
    echo '<tr>',PHP_EOL;
    echo '<th style="width:25px;"><span class="texthead" title="',Lh($str),'">',strtoupper($key),'</span></td>';
    echo '<td class="help">',$arrTexts[$key],'</td>';
    echo '<td style="width:180px"><a href="qtg_adm_txt.php?file=config/',$arrFiles[$key],'&help=Edit_wait" onclick="return qtEdited(bEdited,e0);">',$arrFiles[$key],'</a></td>';
    echo '</tr>',PHP_EOL;
  }
  echo '
  </table>
  ';
}

// --------
// HTML END
// --------

include 'qtg_inc_ft.php';