<?php
// QuickTalk Guestbook 4.0.3 build:20220105
session_start(); if ( empty($_SESSION['qtgAuth']) ) { header('Location: qtg_login.php'); die('Access denied.'); }

require 'qtg_init.php'; $qtg_skin='bin/css';

include getLangDir().'qtg_adm.php';
include 'bin/qtg_fn_stat.php';

// --------
// INITIALISE
// --------

$y = (int)date('Y'); if ( (int)date('n')<2 ) $y--; // reference year
$y0 = $y-1; // comparison year (for variation computation)
$bt = 'm'; // blocktime: m=month, q=quarter, d=10days
$type = 'b'; // graph type: l=line, b=bar

$oP->selfname=$L['Statistics'];
$oP->selfurl='qtg_adm_stat.php';

$oOpt = new cStatOptions();

// --------
// SUBMITTED
// --------

$pan = '';
if ( isset($_GET['type']) )
{
  $type = $_GET['type']==='l' ? 'l' : 'b';
}
if ( isset($_GET['bt']) )
{
  if ( $_GET['bt']==='q' || $_GET['bt']==='d' ) $bt=$_GET['bt'];
}
if ( isset($_GET['y']) )
{
  $y = (int)strip_tags($_GET['y']);
  if ( !QTisbetween($y,2000,(int)date('Y')+1) ) die('Invalid target year');
}
if ( isset($_GET['y0']) && is_numeric($_GET['y0']) )
{
   $y0 = (int)$_GET['y0'];
   if ( $y0<2000 || $y0>(int)date('Y')+1 || $y0>=$y ) { $y0=$y-1; $oP->err=L('Reference_year_invalid'); }
}

// --------
// COMPUTE STATISTICS
// --------

$arrYears = array($y0,$y); // for Trends analysis uses 2 years
$urlArg = 'y='.$y.(isset($_GET['y0']) ? '&y0='.$y0 : '').'&type='.$type;

include 'qtg_adm_stat_inc.php';

// --------
// HTML START
// --------

if ( file_exists('bin/js/Chart.min.css') && file_exists('bin/js/Chart.min.js') )
{
$oHtml->links[] = '<link rel="stylesheet" type="text/css" href="bin/js/Chart.min.css" />';
$oHtml->scripts[] = '<script type="text/javascript" src="bin/js/Chart.min.js"></script>';
}
$oHtml->scripts[] = '<script type="text/javascript">
var useTime = "'.$bt.'"; 
var useType = "'.$oOpt->type.'"; 
var useGpc = '.($oOpt->gpc ? 'true' : 'false').';
var useDpc = '.($oOpt->dpc ? 'true' : 'false').';
var usePlot = "'.$oOpt->plot.'";
var panHref = "'.$oP->selfurl.'?'.$urlArg.'";
function changeArg()
{
  var ids = ["g","gt","d","dt"];
  for (var i=0;i<ids.length;++i)
  {
  var a = document.getElementById("pan_"+ids[i]);
  if ( a ) a.href = panHref + "&pan=" + ids[i] + "&bt=" + useTime + "&ch=" + useType + (useGpc ? "1" : "0") + (useDpc ? "1" : "0") + usePlot;
  }
  // sub tab menu
  ids = ["q","m","d"];
  for (var i=0;i<ids.length;++i)
  {
  var a = document.getElementById("subpan_"+ids[i]);
  if ( a ) a.href = panHref + "&pan=" + "'.$pan.'" + "&bt=" + ids[i] + "&ch=" + useType + (useGpc ? "1" : "0") + (useDpc ? "1" : "0") + usePlot;
  }
}
function changeReferenceYear(y)
{
  var y0 = doc.getElementById("y0").value;
  if ( y0=="" || y0>=y ) y0=y-1;
  doc.getElementById("y0label").innerHTML=y0;
  doc.getElementById("y0").value=y0;
  doc.getElementById("y0").style.display="none";
  var op = document.getElementById("y0").getElementsByTagName("option");
  for (var i=0; i<op.length; i++) { op[i].disabled = op[i].value>=y; }
}
function showReferenceYear(y0)
{
  if (y0>=doc.getElementById("y").value) y0=doc.getElementById("y").value-1;
  doc.getElementById("y0label").innerHTML=y0;
  doc.getElementById("y0").value=y0;
  doc.getElementById("y0").style.display="none";
}
function chartY(ids)
{
  if ( !Array.isArray(ids) ) ids = [ids];
  var pc = document.getElementById("gPercent").checked;
  for (var i=0;i<ids.length;++i)
  {
    var n = ids[i];
    // use global chart{n} and c{n}
    var chart = window["chart"+n];
    var c = window["c"+n];
    if ( pc && c.datapc )
    {
      chart.data.datasets[0].data = c.datapc[0]; 
      if ( c.data.length===2 ) chart.data.datasets[1].data = c.datapc[1]; 
    }
    else
    {
      chart.data.datasets[0].data = pc ? qtPercent(c.data[0]) : c.data[0];
      if ( c.data.length===2 ) chart.data.datasets[1].data = pc ? qtPercent(c.data[1]) : c.data[1];
    }
    chart.options.title.text = pc ? c.title+" (%)" : c.title;
    if ( c.data.length===2 ) chart.data.datasets[1].label = pc ? c.label[1]+" "+c.title+" (%)" : c.label[1]+" "+c.title;
    chart.options.scales.yAxes[0].ticks.suggestedMax = pc ? 100 : c.maxy;
    chart.update();
  }
}
function makeChart(ids)
{
  if ( !Array.isArray(ids) ) ids = [ids];
  type = document.getElementById("chartsType").value==="l" ? "line" : "bar";
  for (var i=0;i<ids.length;++i)
  {
    var n = ids[i];
    var ctx = document.getElementById("chart"+n);
    var c = window["c"+n];
    window["chart"+n] = new Chart(ctx, {
      type: type,
      data: {
        labels: labels,
        datasets: c.data.length===2
          ? [{label: c.label[0], data: c.data[0], backgroundColor: "rgba("+c.color[0]+", 0.7)",borderColor: "rgba("+c.color[0]+", 1)", borderWidth: 1},
             {label: c.label[1]+" "+c.title, data: c.data[1], backgroundColor: "rgba("+c.color[1]+", 0.7)",borderColor: "rgba("+c.color[1]+", 1)", borderWidth: 1}]
          : [{label: c.label[0], data: c.data[0], backgroundColor: "rgba("+c.color[0]+", 0.7)",borderColor: "rgba("+c.color[0]+", 1)", borderWidth: 1}]
        },
      options: {
        scales: {
          yAxes: [{
            ticks: {
              beginAtZero: true,
              suggestedMax: c.maxy,
              precision: 0
            }
          }]
        },
        title: { display: c.data.length===1, text: c.title },
        legend: { display: c.data.length===2, labels: { boxWidth: 15 } }
      }
    });
  }
  chartY(ids);
}
function displayCharts(ids)
{
  var option = document.getElementById("chartsShow").value;
  if ( !Array.isArray(ids) ) ids = [ids];
  for (var i=0;i<ids.length;++i)
  {
    var n = ids[i];
    switch(option)
    {
    case "a": document.getElementById("chart"+n).style.display = "block"; break;
    case "v": document.getElementById("chart"+n).style.display = window["c"+n].data.length===1 ? "block" : "none"; break;
    default: document.getElementById("chart"+n).style.display = window["c"+n].data.length===2 ? "block" : "none"; break;
    }
  }
}
function resetCharts(ids,type)
{
  if ( !Array.isArray(ids) ) ids = [ids];
  for (var i=0;i<ids.length;++i)
  {
    var n = ids[i];
    var chart = window["chart"+n];
    var labels = chart.data.labels;
    chart.destroy();
    makeChart(n);
  }
}
function tableFill(tableid,style=true)
{
  var pc = document.getElementById("tPercent").checked;
  var data = window[tableid+"_data"+(pc ? "_pc" : "")];
  for (var i=0;i<data.length;++i)
  {
    for(var j=0;j<data[i].length;++j)
    {
      var cell = document.getElementById( tableid+"-"+i+"-"+j );
      cell.innerHTML = data[i][j];
      if ( style ) tableCellStyle(tableid+"-"+i+"-"+j);
    }
  }
}
function tableCellStyle(cellid,signPos=true,signNeg=false,colorPos="red",colorNeg="green",colorDefault="#444444")
{
  var pc = document.getElementById("tPercent").checked;
  var cell = document.getElementById( cellid );
  var val = Number(cell.innerHTML);
  cell.style.color = colorDefault;
  if ( pc && val!==0 ) cell.innerHTML = cell.innerHTML+"%";
  if ( signPos && val>0 ) cell.innerHTML = "+"+cell.innerHTML;
  if ( signNeg && val<0 ) cell.innerHTML = "-"+cell.innerHTML;
  if ( colorPos && val>0 ) cell.style.color = colorPos;
  if ( colorNeg && val<0 ) cell.style.color = colorNeg;
}
</script>';

include 'qtg_adm_inc_hd.php';

echo '
<div class="options">',$L['General_stats'],'</div>
<table class="option">
<tr>
<th width="180">',$L['Messages'],'</td>
<td>',$intTotalPost,'</td>
</tr>
<tr>
<th>',$L['Hidden_messages'],'</td>
<td>',$intHiddenPost,'</td>
</tr>
<tr>
<th>',$L['First_message'],'</td>
<td>',QTdatestr($strFirstdate,FORMATDATE,FORMATTIME),'</td>
</tr>
<tr>
<th>',$L['Last_message'],'</td>
<td>',QTdatestr($strLastdate,FORMATDATE,FORMATTIME),'</td>
</tr>
</table>
';

$arrM  = array(); $str = $oP->selfurl.'?'.$urlArg.'&pan='.$pan.'&bt='; // Block time: q=quarter, m=month, d=10days
$arrM[] = new cMenu ( L('Per_q'), 'id=bt_q|href='.$str.'q' );
$arrM[] = new cMenu ( L('Per_m'), 'id=bt_m|href='.$str.'m' );
$arrM[] = new cMenu ( L('Per_d'), 'id=bt_d|href='.$str.'d' );
$arrM[] = '<select id="years" name="years" onchange="submitYear(this.value);">'.QTasTag(array_combine(range($intStartyear,$intEndyear),range($intStartyear,$intEndyear)),$y).'</select>';
$menu = new cMenu ( $arrM, 'id=bt|class=right', ' &middot; ' );
echo $menu->output('bt_'.$bt, 'tag=span|addclass=actif' );

echo '
<div class="options">',L('Messages_per_'.$bt),'</div>
<script type="text/javascript">
function submitYear(y)
{
window.location="qtg_adm_stat.php?y0="+(y-1)+"&y="+y+"&bt='.$bt.'";
}
</script>
';

// Display table header

echo '<table class="option">',PHP_EOL;
echo '<tr>',PHP_EOL;
echo '<th style="width:50px">&nbsp;</td>',PHP_EOL;
switch($bt)
{
case 'q': for ($i=1;$i<=$intMaxBt;++$i) { echo '<th style="text-align:center;">Q',$i,'</td>'; } break;
case 'm': for ($i=1;$i<=$intMaxBt;++$i) { echo '<th style="text-align:center;">',$L['dateMM'][$i],'</td>'; } break;
case 'd': for ($i=1;$i<=$intMaxBt;++$i) { echo '<th style="text-align:center;">',str_replace(' ','<br>',QTdatestr(DateAdd($strTendaysago,$i,'day'),'d M','')),'</td>'; } break;
}
echo '<th style="text-align:center;"><b>',($bt==='d' ? '10 '.strtolower(L('Days')) : L('Total')),'</b></td>
</tr>';

// DISPLAY MESSAGES

foreach($arrYears as $y)
{
  echo '<tr>',PHP_EOL;
  echo '<th>',$y,'</td>',PHP_EOL;
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
  {
    echo '<td style="text-align:center;">',(isset($arrD[$y]['T'][$intBt]) ? $arrD[$y]['T'][$intBt] : '&middot;'),'</td>',PHP_EOL;
  }
  echo '<td style="text-align:center;padding:5px;"><b>',$arrS[$y]['T'],'</b></td>',PHP_EOL;
  echo '</tr>';
}
echo '</table>',PHP_EOL;

// After values display, change the null values to zero to be able to make charts

foreach($arrYears as $i) 
{
  $arrD[$i]['T']=QTarrayzero($arrD[$i]['T']);
  $arrD[$i]['H']=QTarrayzero($arrD[$i]['H']);
  $arrD[$i]['U']=QTarrayzero($arrD[$i]['U']);
}

// GRAPH

if ( !file_exists('bin/js/Chart.min.css') || !file_exists('bin/js/Chart.min.js') ) { echo '<p>Missing chart library...</p>'; exit; }

$arrA = array_values(GetAbscise($bt,$intMaxBt,$strTendaysago)); // abscisse (not indexed)
$arrC = array(); // 3 html colors (by year)
$arrCj = array(); // 3 rgb colors (by year)
$arrC[$y0] = array('#6060FF', '#F1B8FF', '#00E7B7');
$arrCj[$y0] = array('96,96,255', '241,184,255', '0,231,183');
$arrC[$y] = array('#000066', '#990099', '#009999');
$arrCj[$y] = array('0,0,102', '153,0,153', '0,153,153');

echo '<div class="flex-u">
<div><h2>',L('Charts'),'</h2></div>
<div id="chartoptions" class="right">
<p>',L('Charts_options'),'&nbsp; <select id="chartsType" onchange="useType=this.value;resetCharts([1,2,3,4],useType);changeArg();">
<option value="b"',($oOpt->type==='b'? QSEL : ''),'>',L('Bar'),'</option>
<option value="l"',($oOpt->type==='l' ? QSEL : ''),'>',L('Line'),'</option>
</select> &nbsp; <input type="checkbox" id="gPercent" onclick="useGpc=this.checked;chartY([1,2,3,4]);changeArg();" '.($oOpt->gpc ? QCHE :'').'> <label for="gPercent">'.L('Percent').'</label>
</p>
</div>
</div>
<div class="flex-u">
<div class="chart"><canvas id="chart1" width="350px" height="250px"></canvas></div>
<div class="chart"><canvas id="chart2" width="350px" height="250px"></canvas></div>
</div>
';
echo '<script>
var labels = ',json_encode($arrA),';
var c1 = {
  title: "',html_entity_decode(L('Items_per_'.$bt), ENT_NOQUOTES),'",
  label: ["',$y,'"],
  data: [',json_encode($arrD[$y]['T']),'],
  datapc: null,
  maxy: ',QTroof($arrD[$y]['T']),',
  color: ["',$arrCj[$y][0],'"]
  };
var c2 = {
  title: "',html_entity_decode(L('Hidden_messages'), ENT_NOQUOTES),'",
  label: ["',html_entity_decode(L('To_review')),'",""],
  data: [',json_encode($arrD[$y]['U']),',',json_encode($arrD[$y]['H']),'],
  datapc: null,
  maxy: ',QTroof($arrD[$y]['H'],$arrD[$y]['U']),',
  color: ["',$arrCj[$y0][1],'", "',$arrCj[$y][1],'"]
  }; 
makeChart([1,2]);
</script>
';

// IP STATS (by year) are stored in an array

$ips = memcacheGet(QT.'-ips');
if ( $ips===false || empty($ips[$y]) )
{
  if ( QT_FILE )
  {
    $arr = $oDB->GetFiles('',0,$y,$y);
    foreach($arr as $k=>$v) 
    {
        $a = explode('-',$v);
        if ( isset($a[2]) ) {$arr[$k]=$a[2];} else {unset($arr[$k]);}
    }
    $arr = array_count_values($arr);
    arsort($arr);
    $ips[$y] = '';
    $i=0;
    foreach($arr as $v=>$n) 
    {
      if ( $i===4 ) break;
      $ips[$y] .= '<span class="bold">'.$n.'</span> from '.str_replace('w',':',$v).'<br>';
      ++$i;
    }
    if ( empty($ips[$y]) ) $ips[$y] = '<span class="disabled">(no message in '.$y.')</span><br>';
  }
  else
  {
    switch($oDB->type)
    {
    case 'pdo.pg':
    case 'pg': $oDB->Query( 'SELECT ip,count(ip) as countip FROM'.TABMESSAGE.' WHERE SUBSTRING(issuedate,1,4)="'.$y.'" GROUP BY ip ORDER BY countip DESC' ); break;
    case 'pdo.sqlite':
    case 'sqlite':
    case 'pdo.oci':
    case 'oci': $oDB->Query( 'SELECT ip,count(ip) as countip FROM '.TABMESSAGE.' WHERE SUBSTR(issuedate,1,4)="'.$y.'" GROUP BY ip ORDER BY countip DESC' ); break;
    default: $oDB->Query( 'SELECT ip,count(ip) as countip FROM '.TABMESSAGE.' WHERE LEFT(issuedate,4)="'.$y.'" GROUP BY ip ORDER BY countip DESC' ); break;
    }
    $row = $oDB->Getrow();
    $ips[$y]='';
    $i=0;
    while($row=$oDB->Getrow())
    {
      if ($i===4) break;
      $ip = $row['ip'];
      if ($ip=='') $ip='?.?.?.?';
      $ips[$y] .= '<span class="bold">'.$row['countip'].'</span> from '.$ip.'<br>';
      ++$i;
    }
    if ( empty($ips[$y]) ) $ips[$y] = '<span class="disabled">(no message in '.$y.')</span><br>';
  }
  memcacheSet(QT.'-ips',$ips);
  //$oHtml->showlog[]='Info: memcache '.QT.'-ips rebuild';
}
echo '
<div class="options">IP ',L('statistics'),'</div>
<table  class="option">
<tr valign="top">
<th width="180">Top 5 IP<br>('.$y.')</td>
<td>',$ips[$y],'</td>
</tr>
</table>
<br>
';

// --------
// HTML END
// --------

echo '<p class="disabled" style="margin:0">'.L('Stats_note').'</p>';

include 'qtg_inc_ft.php';