<?php

// QuickTalk guestbook 4.0 build:20200514

// Initialise array values. When a value is missing the display will show &middot;
// Note: memcache(qtg-count) contains only visible messages. Here $oDB->arrFiles is rebuild to include all messages

$intStartyear = 0;
$intStartmonth = 0;
$intEndyear = 0;
$intEndmonth = 0;
$strLastdaysago = date('Ymd');
$strTendaysago = DateAdd($strLastdaysago,-10,'day');
$intHiddenPost = 0;
if ( QT_FILE ) $oDB->arrFiles = false; // Force $oDB->arrFiles to be rebuild
// Stats (total,hidden,first,last) from memcache
$stats = memcacheGet(QT.'-stats');
if ( $stats===false )
{
  $stats = array();
  // Count All
  if ( QT_FILE )
  {
    $stats['total'] = $oDB->FilesCount('',0,date('Ym'),'0',true);
    if ( $stats['total']>0 )
    {
    $stats['hidden'] = count($oDB->GetFilesSubset('n;u'));
    $stats['first'] = substr($oDB->firstfile,0,8).substr($oDB->firstfile,9,6);
    $stats['last'] = substr($oDB->lastfile,0,8).substr($oDB->lastfile,9,6);
    }
  }
  else
  {
    $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0' );
    $row = $oDB->Getrow();
    $stats['total'] = (int)$row['countid'];
    if ( $stats['total']>0 )
    {
    $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y"' );
    $row = $oDB->Getrow();
    $stats['hidden'] = (int)$row['countid'];
    $oDB->Query( 'SELECT MIN(issuedate) as firstdate,MAX(issuedate) as lastdate FROM '.TABMESSAGE.' WHERE id>=0 AND issuedate>="2000"' );
    $row = $oDB->Getrow();
    $stats['first'] = $row['firstdate'];
    $stats['last'] = $row['lastdate'];
    }
  }
  memcacheSet(QT.'-stats',$stats);
  //$oHtml->showlog[]='Info: memcache '.QT.'-stats rebuild';
}
if ( QT_FILE && $oDB->arrFiles===false ) $oDB->FilesCount('',0,date('Ym')); // Uses GetFiles() to populate $oDT->arrFiles (if not yet done)
$intTotalPost = empty($stats['total']) ? 0 : $stats['total'];
$intHiddenPost = empty($stats['hidden']) ? 0 : $stats['hidden'];
$strFirstdate = empty($stats['first']) ? 0 : $stats['first'];
$strLastdate = empty($stats['last']) ? 0 : $stats['last'];
if ( empty($strFirstdate) ) $strFirstdate=date('Ymd');
if ( empty($strLastdate) ) $strLastdate=date('Ymd');
$strLastdaysago = substr($strLastdate,0,8);
$strTendaysago = DateAdd($strLastdaysago,-10,'day');
$intStartyear = (int)substr($strFirstdate,0,4);
$intStartmonth = (int)substr($strFirstdate,4,2);
$intEndyear = (int)date('Y');
$intEndmonth = (int)date('n');

switch($bt)
{
case 'q': $intMaxBt=4; break;
case 'd': $intMaxBt=10; break;
case 'm': $intMaxBt=12; break;
default: die('Invalid blocktime');
}

$intCurrentYear = $y;
$strCurrentTendaysago = $strTendaysago;

$arrD = array(); // Datasets
$arrS = array(); // Datasets_sum

foreach($arrYears as $i)
{
  $arrD[$i]['T'] = array_fill(1,$intMaxBt,null); //values (index Q:1-4,M:1-12,D:1-10) set to null
  $arrS[$i]['T'] = 0; //sum set to 0
  $arrD[$i]['H'] = array_fill(1,$intMaxBt,null);
  $arrD[$i]['U'] = array_fill(1,$intMaxBt,null);
  if ( $intCurrentYear==$i ) { $strTendaysago = $strCurrentTendaysago; } else { $strTendaysago = DateAdd(substr($strTendaysago,0,8),-1,'year'); }
}

// COUNT MESSAGES

// -----
foreach($arrYears as $i) {
// -----

if ( $intCurrentYear==$i ) { $strTendaysago = $strCurrentTendaysago; } else { $strTendaysago = DateAdd(substr($strTendaysago,0,8),-1,'year'); }

for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
{
  // check limits (startdate/enddate)
  if ( $i<$intStartyear ) continue;
  if ( $i==$intStartyear )
  {
    if ( $bt=='m' ) {
    if ( $intBt<$intStartmonth ) {
    continue;
    }}
    if ( $bt=='q' ) {
    if ( ($intBt==1 && $intStartmonth>3) || ($intBt==2 && $intStartmonth>6) || ($intBt==3 && $intStartmonth>9) ) {
    continue;
    }}
  }
  if ( $i>=$intEndyear )
  {
    if ( $bt=='m' ) {
    if ( $intBt>$intEndmonth ) {
    continue;
    }}
    if ( $bt=='q' ) {
    if ( ($intBt==2 && $intEndmonth<4) || ($intBt==3 && $intEndmonth<7) || ($intBt==4 && $intEndmonth<10) ) {
    continue;
    }}
  }
  if ( $bt=='d') $strBtDay = DateAdd($strTendaysago,$intBt,'day');

  switch($oDB->type)
  {
  case 'pdo.mysql':
  case 'mysql4':
  case 'mysql':
  case 'pdo.sqlsrv':
  case 'sqlsrv':
    if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND LEFT(issuedate,6)="'.($i*100+$intBt).'"' );
    if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND LEFT(issuedate,6)>"'.($i*100+($intBt-1)*3).'" AND LEFT(issuedate,6)<="'.($i*100+($intBt*3)).'"' );
    if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND LEFT(issuedate,8)="'.$strBtDay.'"' );
    $row = $oDB->Getrow();
    if ( $intCurrentYear==$i && count($row)>0 )
    {      
      if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND LEFT(issuedate,6)="'.($i*100+$intBt).'"' );
      if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND LEFT(issuedate,6)>"'.($i*100+($intBt-1)*3).'" AND LEFT(issuedate,6)<="'.($i*100+($intBt*3)).'"' );
      if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND LEFT(issuedate,8)="'.$strBtDay.'"' );
      $hrow = $oDB->Getrow();
      if ( count($hrow)>0 )
      {      
        if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND LEFT(issuedate,6)="'.($i*100+$intBt).'"' );
        if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND LEFT(issuedate,6)>"'.($i*100+($intBt-1)*3).'" AND LEFT(issuedate,6)<="'.($i*100+($intBt*3)).'"' );
        if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND LEFT(issuedate,8)="'.$strBtDay.'"' );
        $urow = $oDB->Getrow();
      }
    }
    break;
  case 'pdo.pg':
  case 'pg':
    if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTRING(issuedate,1,6)="'.($i*100+$intBt).'"' );
    if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTRING(issuedate,1,6)>"'.($i*100+($intBt-1)*3).'" AND SUBSTRING(issuedate,1,6)<="'.($i*100+($intBt*3)).'"' );
    if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTRING(issuedate,1,8)="'.$strBtDay.'"' );
    $row = $oDB->Getrow();
    if ( $intCurrentYear==$i && count($row)>0 )
    {      
      if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND SUBSTRING(issuedate,1,6)="'.($i*100+$intBt).'"' );
      if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND SUBSTRING(issuedate,1,6)>"'.($i*100+($intBt-1)*3).'" AND SUBSTRING(issuedate,1,6)<="'.($i*100+($intBt*3)).'"' );
      if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND SUBSTRING(issuedate,1,8)="'.$strBtDay.'"' );
      $hrow = $oDB->Getrow();
      if ( count($hrow)>0 )
      {      
        if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND SUBSTRING(issuedate,1,6)="'.($i*100+$intBt).'"' );
        if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND SUBSTRING(issuedate,1,6)>"'.($i*100+($intBt-1)*3).'" AND SUBSTRING(issuedate,1,6)<="'.($i*100+($intBt*3)).'"' );
        if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND SUBSTRING(issuedate,1,8)="'.$strBtDay.'"' );
        $urow = $oDB->Getrow();
      }
    }
    break;
  case 'pdo.sqlite':
  case 'sqlite':
    if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTR(issuedate,1,6)="'.($i*100+$intBt).'"' );
    if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTR(issuedate,1,6)>"'.($i*100+($intBt-1)*3).'" AND SUBSTR(issuedate,1,6)<="'.($i*100+($intBt*3)).'"' );
    if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTR(issuedate,1,8)="'.$strBtDay.'"' );
    $row = $oDB->Getrow();
    if ( $intCurrentYear==$i && count($row)>0 )
    {      
      if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND SUBSTR(issuedate,1,6)="'.($i*100+$intBt).'"' );
      if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND SUBSTR(issuedate,1,6)>"'.($i*100+($intBt-1)*3).'" AND SUBSTR(issuedate,1,6)<="'.($i*100+($intBt*3)).'"' );
      if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND SUBSTR(issuedate,1,8)="'.$strBtDay.'"' );
      $hrow = $oDB->Getrow();
      if ( count($hrow)>0 )
      {      
        if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND SUBSTR(issuedate,1,6)="'.($i*100+$intBt).'"' );
        if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND SUBSTR(issuedate,1,6)>"'.($i*100+($intBt-1)*3).'" AND SUBSTR(issuedate,1,6)<="'.($i*100+($intBt*3)).'"' );
        if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND SUBSTR(issuedate,1,8)="'.$strBtDay.'"' );
        $urow = $oDB->Getrow();
      }
    }
    break;
  case 'pdo.oci':
  case 'oci':
    if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTR(issuedate,1,6)="'.($i*100+$intBt).'"' );
    if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTR(issuedate,1,6)>"'.($i*100+($intBt-1)*3).'" AND SUBSTR(issuedate,1,6)<="'.($i*100+($intBt*3)).'"' );
    if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTR(issuedate,1,8)="'.$strBtDay.'"' );
    $row = $oDB->Getrow();
    if ( $intCurrentYear==$i && count($row)>0 )
    {      
      if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND SUBSTR(issuedate,1,6)="'.($i*100+$intBt).'"' );
      if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND SUBSTR(issuedate,1,6)>"'.($i*100+($intBt-1)*3).'" AND SUBSTR(issuedate,1,6)<="'.($i*100+($intBt*3)).'"' );
      if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible<>"Y" AND SUBSTR(issuedate,1,8)="'.$strBtDay.'"' );
      $hrow = $oDB->Getrow();
      if ( count($hrow)>0 )
      {      
        if ( $bt=='m') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND SUBSTR(issuedate,1,6)="'.($i*100+$intBt).'"' );
        if ( $bt=='q') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND SUBSTR(issuedate,1,6)>"'.($i*100+($intBt-1)*3).'" AND SUBSTR(issuedate,1,6)<="'.($i*100+($intBt*3)).'"' );
        if ( $bt=='d') $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="U" AND SUBSTR(issuedate,1,8)="'.$strBtDay.'"' );
        $urow = $oDB->Getrow();
      }
    }
    break;
  case 'file':
    $row = array();
    if ( $bt=='m') $row['countid'] = count( $oDB->GetFilesSubset('',0,$i*100+$intBt,$i*100+$intBt) );
    if ( $bt=='q') $row['countid'] = count( $oDB->GetFilesSubset('',0,$i*100+($intBt*3),$i*100+($intBt-1)*3+1) );
    if ( $bt=='d') $row['countid'] = count( $oDB->GetFilesSubset('',0,$strBtDay,$strBtDay) );
    if ( $intCurrentYear==$i && count($row)>0 )
    {
      $hrow = array();
      if ( $bt=='m') $hrow['countid'] = count( $oDB->GetFilesSubset('n;u',0,$i*100+$intBt,$i*100+$intBt) );
      if ( $bt=='q') $hrow['countid'] = count( $oDB->GetFilesSubset('n;u',0,$i*100+($intBt*3),$i*100+($intBt-1)*3+1) );
      if ( $bt=='d') $hrow['countid'] = count( $oDB->GetFilesSubset('n;u',0,$strBtDay,$strBtDay) );
      if ( count($hrow)>0 )
      {      
        $urow = $oDB->Getrow();
        if ( $bt=='m') $urow['countid'] = count( $oDB->GetFilesSubset('u',0,$i*100+$intBt,$i*100+$intBt) );
        if ( $bt=='q') $urow['countid'] = count( $oDB->GetFilesSubset('u',0,$i*100+($intBt*3),$i*100+($intBt-1)*3+1) );
        if ( $bt=='d') $urow['countid'] = count( $oDB->GetFilesSubset('u',0,$strBtDay,$strBtDay) );
      }
    }
    break;
  default: die('Unknown db type '.$oDB->type);
  }
  $arrD[$i]['T'][$intBt] = (int)$row['countid'];
  $arrS[$i]['T'] += $arrD[$i]['T'][$intBt]; // total
  if ( $intCurrentYear==$i && isset($hrow['countid']) ) $arrD[$i]['H'][$intBt] = (int)$hrow['countid'];
  if ( $intCurrentYear==$i && isset($urow['countid']) ) $arrD[$i]['U'][$intBt] = (int)$urow['countid'];
}

// -----
}
// -----