<?php
// QuickTalk 4.0.3 build:20210106
// php minimum version 5.2.7

define('APP', 'qtg'); // php file prefix
define('VERSION', '4.0.3');
define('BUILD', 'build:20220106');

// -----------------
// Connexion config and saved settings
// -----------------
require 'config/config.php'; if ( empty($qtg_install) || !is_string($qtg_install) ) $qtg_install='1';
define('QT', 'qtg'.substr($qtg_install,-1));
define('QT_FILE', $qtg_dbsystem==='file');

require 'config/config_site.php'; if ( !isset($qtg_language) ) $qtg_language='en'; // $qtg_language is the default language, $_SESSION[QT]['language'] is the user language
include 'config/config_lang.php'; if ( !defined('LANGUAGES') ) define('LANGUAGES', ['en'=>'EN English']);
include 'config/config_stop.php';
if ( !isset($qtg_reviewer) ) $qtg_reviewer=false;
if ( !isset($qtg_actif) ) $qtg_actif=true;
if ( empty($qtg_type) ) $qtg_type='1';
if ( !isset($qtg_checkurl) ) $qtg_checkurl=false;
if ( !isset($qtg_meaning) ) $qtg_meaning=false;
if ( !isset($qtg_checklang) ) $qtg_checklang=false; if ( $qtg_checkurl && $qtg_bbc_url ) $qtg_checkurl=false; // checkurl disabled when bbc url is allowed

require 'config/config_map.php';
if ( empty($qtg_gkey) || !isset($qtg_gkey[3]) ) $qtg_gkey=false;
if ( $qtg_gkey ) $qtg_separateform=true; // mandatory when map is active
if ( !isset($qtg_mapontop) ) $qtg_mapontop=true;

if ( substr($qtg_skin,0,5)!='skin/' ) $qtg_skin = 'skin/'.$qtg_skin;

// -----------------
// System constants (this CANNOT be changed by webmasters)
// -----------------
define('FORMATDATE', isset($qtg_formatdate) ? $qtg_formatdate : 'j-M-Y');
define('FORMATTIME', isset($qtg_formattime) ? $qtg_formattime : 'G:i');
define('TABMESSAGE', $qtg_prefix.'qtgmessage');
define('QSEL', ' selected'); // for XHTML use ' selected="selected"'
define('QCHE', ' checked'); // for XHTML use ' checked="checked"'
define('JQUERY_OFF', 'bin/js/jquery.min.js'); // jQuery resource when offline. This will be used if CDN (defined here after) is not possible.
define('JQUERYUI_OFF', 'bin/js/jquery-ui.min.js');
define('JQUERYUI_CSS_OFF', 'bin/css/jquery-ui/themes/base/jquery-ui.css');

// -----------------
// Function constants (this can be changed by webmasters)
// -----------------
define('QT_URLREWRITE',false);
// URL rewriting (for expert only):
// Rewriting url requires that your server is configured with following rule for the application folder: RewriteRule ^(.+)\.html(.*) qtg_$1.php$2 [L]
// This can NOT be activated if you application folder contains html pages (they will not be accessible anymore when urlrewriting is acticated)
define('QT_SHOW_CONTRAST',true); // Show contrast button in upper right corner
define('QT_CONVERT_AMP', false); // Convert & to &amp; before saving in the db. TRUE will make impossible to insert symbols or special characters (like &#nnnn;)
define('QT_NOTIFYAFTER', 50); // Monthly notification. One notification is send when the (n)th messages is recieved. No message will be send if less than n messages are inserted during the month.
define('QT_FLOOD', 5); // Prevent double-post of message by a user (delay in seconds)
define('QT_JAVAMAIL', true); // Email address protected by javascript
define('QT_SMARTCUT', 4);
// Smartcut is a tolerance value (0-9) while truncating long messages.
// Value 0 will truncate at the exact specified length.
// Value N (recommanded 4) will truncate with following advantages:
// * truncate can preverse up to N characters if the total length is within this tolerance
// * truncate will take place after the characters ,;:.)]}!?
// Ex: If you decide to tuncate message after 200 characters with smartcut of 4, the total length can be 204 characters maximum and the function will try to preserve the last word or the last punctuation character.
define('MEMCACHE_HOST', 'localhost'); // Memcache allow storing frequently used values in memcache server. Deamon should be on localhost: define('MEMCACHE_HOST', 'localhost');
define('MEMCACHE_PORT', 11211); // Memcache port (integer). Default port is 11211.
define('MEMCACHE_TIMEOUT', 86400); // Memcache expire (delay in seconds).
// If memcache is not available on your server you can use define('MEMCACHE_HOST', false); and use the fallback cache on the file system.
define('MEMCACHE_FALLBACK', 'data/cache/'); // When running without memcache deamon, the application uses data/cache/ as cache system. Set FALSE don't use file cache.
// To clear the cache (on the deamon or in file system) add "?memcacheflush" to the url. You must be logged as administrator to execute a memcachflush.

// -----------------
// JQUERY (this can be changed by webmaster)
// -----------------
// Content Delivery Network for jQuery and jQuery-UI. Using a CDN will increase performances.
// Possible CDN are: Google, Microsoft, jQuery-Media-Temple.
// You can also decide to use your local copy (in the bin/ directory) to avoid using a CDN.
define('JQUERY_CDN', '//ajax.googleapis.com/ajax/libs/jquery/2.0.3/jquery.min.js');
  // define('JQUERY_CDN', '//ajax.aspnetcdn.com/ajax/jQuery/jquery-2.0.3.min.js');
  // define('JQUERY_CDN', '//code.jquery.com/jquery-2.0.3.min.js');
  // define('JQUERY_CDN', 'bin/js/jquery.min.js');
define('JQUERYUI_CDN', '//ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/jquery-ui.min.js');
  // define('JQUERYUI_CDN', '//ajax.aspnetcdn.com/ajax/jquery.ui/1.10.3/jquery-ui.min.js');
  // define('JQUERYUI_CDN', '//code.jquery.com/ui/1.10.3/jquery-ui.js');
  // define('JQUERYUI_CDN', 'bin/js/jquery-ui.min.js');
define('JQUERYUI_CSS_CDN', '//ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/themes/smoothness/jquery-ui.min.css');
  // define('JQUERYUI_CSS_CDN', '//ajax.aspnetcdn.com/ajax/jquery.ui/1.10.3/themes/smoothness/jquery-ui.min.css');
  // define('JQUERYUI_CSS_CDN', '//code.jquery.com/ui/1.10.3/themes/smoothness/jquery-ui.css');
  // define('JQUERYUI_CSS_CDN', 'bin/css/jquery-ui/themes/base/jquery-ui.css');

// -----------------
// Classes and functions
// -----------------
require 'bin/class_qtg_html.php';
require 'bin/class_qtg_post.php';
require 'bin/lib_qt_sys.php';
require 'bin/lib_qt_txt.php';
require 'bin/lib_qtg_base.php';

// CHECK SETTING

foreach(array('qtg_dbsystem','qtg_host','qtg_database','qtg_prefix','qtg_user','qtg_pwd','qtg_user_2','qtg_pwd_2') as $Variable) if ( !isset($$Variable) ) echo $Variable.' not defined check the file config/config.php...';
if ( empty($qtg_dbsystem) ) die ('wrong qtg_dbsystem in file config/config.php');
if ( !QTisbetween($qtg_page_size,1,100) )   { echo 'posts_per_page invalid (1-100)'; $qtg_page_size=10; }
if ( !isset($qtg_menulang) ) $qtg_menulang=false;
// CHANGE LANGUAGE if required (by coockies or by menu-click)
$str = '';
if ( empty($_SESSION[QT]['language']) ) $_SESSION[QT]['language'] = $qtg_language;
if ( isset($_COOKIE[QT.'_cooklang']) ) $str = $_COOKIE[QT.'_cooklang']; // read cookie
if ( isset($_GET['lang']) ) $str = $_GET['lang']; // read user request
if ( !empty($str) && $str!=$_SESSION[QT]['language'] )
{
  if ( array_key_exists($str,LANGUAGES) ) {
    $_SESSION[QT]['language'] = $str; // Uses coockie or language menu selection (if definition is in config_lang.php)
    if ( PHP_VERSION_ID<70300 ) {
      setcookie(QT.'_cooklang', $str, time()+3600*24*100, '/');
    } else {
      setcookie(QT.'_cooklang', $str, array('expires'=>time()+3600*24*100,'path'=>'/','samesite'=>'Strict'));
    }
  }
  else
  {
    $error = 'Wrong iso code language';
  }
}
if ( empty($_SESSION[QT]['language']) ) $_SESSION[QT]['language'] = 'en'; //fallback if language change failed

// ----------------
// INITIALIASE Classes and Variable
// ----------------

$error = ''; // Required when server uses register_global_on
$warning = ''; // Required when server uses register_global_on
$arrCoord = array(); // Can be used by map extension
$cache = memcacheCreate($warning); // returns memcache object or false (can also issue a $warning message if connection failed)
if ( QT_FILE )
{
  require 'bin/class_qtg_dt.php';
  $oDB = new cDT($qtg_host);
}
else
{
  require 'bin/class_qtg_db.php';
  $oDB = new cDB($qtg_dbsystem,$qtg_host,$qtg_database,$qtg_user,$qtg_pwd);
}
if ( !empty($oDB->error) ) die ('<p style="color:red">Connection with database failed.<br>Please contact the webmaster for further information.</p><p>The webmaster must check that server is up and running, and that the settings in the config file are correct for the database.</p>');

$oP = new cVIP();

// Check language folder (all pages except qtg_adm_conf that have his own check)

if ( !file_exists('language/'.$qtg_language.'/qtg_main.php') ) { echo '<p id="error-language" style="color:red">Note for the administrator: Language folder ['.$qtg_language.'] not found. Select and save the default language in Administration Configuration page.</p>'; if ( $_SESSION[QT]['language']===$qtg_language ) $_SESSION[QT]['language']='en'; }
if ( $qtg_language!==$_SESSION[QT]['language'] && !file_exists('language/'.$_SESSION[QT]['language'].'/qtg_main.php') ) { echo '<p id="error-language" style="color:red">Note for the administrator: Language folder ['. $_SESSION[QT]['language'].'] not found. Select and save the default language in Administration Configuration page.</p>'; $_SESSION[QT]['language']='en'; }

include getLangDir().'qtg_main.php';
$qtg_tags = array(); // allowed tags
if ( $qtg_bbc_bold ) array_push($qtg_tags,'b','/b');
if ( $qtg_bbc_italic ) array_push($qtg_tags,'i','/i');
if ( $qtg_bbc_underline )array_push($qtg_tags,'u','/u');
if ( $qtg_bbc_url ) array_push($qtg_tags,'url','/url');
if ( $qtg_bbc_smiley ) array_push($qtg_tags,':)',':(',':|',';)',':t',':o',':?',':!',':*');

$qtg_back='<div class="button back"><a id="exiturl" href="'.Href('qtg_index.php').'">'.L('Return'.$qtg_type).'</a></div>';

// Contrast check

if ( QT_SHOW_CONTRAST )
{
  if ( !isset($_SESSION[QT]['contrast']) ) $_SESSION[QT]['contrast']=false;
  if ( isset($_GET['css']) ) $_SESSION[QT]['contrast'] = ($_GET['css']==='contrast');
}

// ----------------
// To overwrite config - special for demo or skin test
// ----------------
if ( !empty($_SESSION['demo_qtg']) )
{
  $qtg_home=''; // remove home button
  if ( isset($_SESSION['demo_qtg_skin']) ) $qtg_skin = $_SESSION['demo_qtg_skin'];
  if ( $qtg_gkey && isset($_SESSION['demo_qtg_mapontop']) ) { memcacheUnset(QT.'-page1'.$_SESSION[QT]['language']); $qtg_mapontop = $_SESSION['demo_qtg_mapontop']; }
}
// ----------------
// Default HTML settings
// ----------------

$oHtml = new cHtml();
$oHtml->html = '<!DOCTYPE html><html xmlns="http://www.w3.org/1999/xhtml" dir="'.(defined('QT_HTML_DIR') ? QT_HTML_DIR : 'ltr').'" xml:lang="'.(defined('QT_HTML_LANG') ? QT_HTML_LANG : 'en').'" lang="'.(defined('QT_HTML_LANG') ? QT_HTML_LANG : 'en').'">';
$oHtml->title = $qtg_title;
$oHtml->metas['charset'] = '<meta charset="'.(defined('QT_HTML_CHAR') ? QT_HTML_CHAR : 'utf-8').'" />';
$oHtml->metas['description'] = '<meta name="description" content="QTG QuickTalk Guestbook" />';
$oHtml->metas['keywords'] = '<meta name="keywords" content="Guestbook,qt-cute,OpenSource" />';
$oHtml->metas['author'] = '<meta name="author" content="qt-cute.org" />';
$oHtml->links['icon'] = '<link rel="shortcut icon" href="'.$qtg_skin.'/qtg_icon.ico" />';
$oHtml->links['css'] = '<link rel="stylesheet" type="text/css" href="'.$qtg_skin.'/qtg.css" />';
$oHtml->links['icons'] = '<link rel="stylesheet" type="text/css" href="bin/font/qtg-icons.css" />';
if ( $qtg_gkey ) $oHtml->links['gmap'] = '<link rel="stylesheet" type="text/css" href="map/gmap/qt-gmap.css" />';
$oHtml->scripts['base'] = '<script type="text/javascript" src="bin/js/qtg_base.js"></script>';

$arrCss = array();
$strLangMenu = '';
$bAdm = false;

// Admin system
define('QT_HASHKEY', $qtg_pwd.$qtg_install);
if ( isset($_GET['memcacheflush']) )
{
  unset($_GET['memcacheflush']);
  $oHtml->showlog[] = empty($_SESSION['qtgAuth']) ? 'Warning: only admin can perform memcacheflush' : 'Info: memcache cleared and rebuild';
  if ( !empty($_SESSION['qtgAuth']) ) memcacheFlush();
}