<?php

/* ============
 * qtg_map_lib.php
 * ------------
 * version: 4.0 build:20200514
 * This is a module library
 * ------------
 * QTgpoint()
 * QTgpointdelete()
 * QTgmapscript()
 * QTgmappoints()
 * ============ */

function MakePoint($y,$x,$title='',$info='',$icon=false)
{
  $aPoint = array( 'y'=>50.847, 'x'=>4.352, 'title'=>$title, 'info'=>$info );
  if ( isset($y) && isset($x) )
  {
    $aPoint['y'] = (float)$y;
    $aPoint['x'] = (float)$x;
  }
  else
  {
    global $qtg_gcenter;
    if ( isset($qtg_gcenter) )
    {
    $aPoint['y'] = (float)QTgety($qtg_gcenter);
    $aPoint['y'] = (float)QTgetx($qtg_gcenter);
    }
  }
  if ( $icon ) $aPoint['icon']=$icon;
  return $aPoint; 
}

// Attention x,y,z MUST be FLOAT (or null) !
// If x,y,z are NULL or not float, these functions will returns FALSE.
// When entity (topic) is created, the x,y,z are null (i.e. no point, no display)

// ---------

function QTgmapApi($strKey='',$strAddLibrary='')
{
  if ( empty($strKey) ) return '';
  return '<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?key='.$strKey.'"></script>'.PHP_EOL.(empty($strAddLibrary) ? '' : $strAddLibrary);
}

// ---------

function QTgmapMarker($centerLatLng='',$draggable=false,$qtg_gsymbol=false,$title='',$info='')
{
  if ( $centerLatLng==='' || $centerLatLng==='0,0' ) return 'marker = null;';
  if ( $centerLatLng==='map' )
  {
    $centerLatLng = 'map.getCenter()';
  }
  else
  {
    $centerLatLng = 'new google.maps.LatLng('.$centerLatLng.')';
  }
  if ( $draggable=='1' || $draggable==='true' || $draggable===true )
  {
  	$draggable='draggable:true, animation:google.maps.Animation.DROP,';
  }
  else
  {
  	$draggable='draggable:false,';
  }
  // check ' are converted to \' before js insertion
  $title = str_replace("'","\'",str_replace("\'","'",$title));
  $info = str_replace("'","\'",str_replace("\'","'",$info));
  return '  marker = new google.maps.Marker({
    position: '.$centerLatLng.',
    map: map,
    '.$draggable.'
    '.QTgmapMarkerIcon($qtg_gsymbol).'
    title: qtHtmldecode("'.$title.'")
  });
  markers.push(marker); '.PHP_EOL.(empty($info) ? '' : '	gmapInfo(marker,\''.$info.'\');');
}

// ---------

function QTgmapMarkerIcon($qtg_gsymbol=false)
{
  // returns the google.maps.Marker.icon argument (or nothing in case of default symbol)
  if ( empty($qtg_gsymbol) ) return '';
  $str = '';
  // icons are 32x32 pixels and the anchor depends on the name: (10,32) for puhspin, (16,32) for point, center form others
  $sym = explode('_',$qtg_gsymbol); // symol first part name (point,pushpin,center)
  switch($sym[0])
  {
  case 'pushpin': $str = 'icon: {url: "map/'.$qtg_gsymbol.'.png", size: new google.maps.Size(32,32), origin: new google.maps.Point(0,0), anchor: new google.maps.Point(10,32)},'; break;
  case 'point': $str = 'icon: {url: "map/'.$qtg_gsymbol.'.png", size: new google.maps.Size(32,32), origin: new google.maps.Point(0,0), anchor: new google.maps.Point(16,32)},'; break;
  default: $str = 'icon: {url: "map/'.$qtg_gsymbol.'.png", size: new google.maps.Size(32,32), origin: new google.maps.Point(0,0), anchor: new google.maps.Point(16,16)},'; break;
  }
  return $str;
}

// ---------

function QTgmapMarkerMapTypeId($qtg_gbuttons)
{
  switch($qtg_gbuttons)
  {
	case 'S':
	case 'SATELLITE': return 'google.maps.MapTypeId.SATELLITE'; break;
	case 'H':
	case 'HYBRID': return 'google.maps.MapTypeId.HYBRID'; break;
	case 'P':
	case 'T':
	case 'TERRAIN': return 'google.maps.MapTypeId.TERRAIN'; break;
	default: return 'google.maps.MapTypeId.ROADMAP';
  }
}

// ---------

function QTgetx($str=null,$onerror=0.0)
{
  // checks
  if ( !is_string($str) ) { if ( isset($onerror) ) return $onerror; die('QTgetx: arg #1 must be a string'); }
  if ( !strstr($str,',') ) { { if ( isset($onerror) ) return $onerror; die('QTgetx: arg #1 must be a string with 2 values'); }}
  $arr = explode(',',$str);
  $str = trim($arr[1]);
  if ( !is_numeric($str) ) { if ( isset($onerror) ) return $onerror; die('QTgetx: x-coordinate is not a float'); }
  Return floatval($str);
}
function QTgety($str=null,$onerror=0.0)
{
  // checks
  if ( !is_string($str) ) { if ( isset($onerror) ) return $onerror; die('QTgety: arg #1 must be a string'); }
  if ( !strstr($str,',') ) { { if ( isset($onerror) ) return $onerror; die('QTgety: arg #1 must be a string with 2 values'); }}
  $arr = explode(',',$str);
  $str = trim($arr[0]);
  if ( !is_numeric($str) ) { if ( isset($onerror) ) return $onerror; die('QTgety: y-coordinate is not a float'); }
  Return floatval($str);
}

// ---------

function QTdd2dms($dd,$intDec=0)
{
  $dms_d = intval($dd);
  $dd_m = abs($dd - $dms_d);
  $dms_m_float = 60 * $dd_m;
  $dms_m = intval($dms_m_float);
  $dd_s = abs($dms_m_float - $dms_m);
  $dms_s = 60 * $dd_s;
  return $dms_d.'&#176;'.$dms_m.'&#039;'.round($dms_s,$intDec).'&quot;';
}