<?php
// QuickTalk Guestbook 4.0.3 build:20220105
session_start();
require 'qtg_init.php';

// SECURITY && closed app

if ( $qtg_checkip ) {
if ( !empty($qtg_checkip_list) ) {
  if ( strstr($qtg_checkip_list,($_SERVER['REMOTE_ADDR'])) ) die($L['E_ip_denied']);
}}
if ( !$qtg_actif && empty($_SESSION['qtgAuth']) )
{
  include 'qtg_inc_hd.php';
  echo PHP_EOL,'<div class="content">',PHP_EOL;
  echo '<p style="text-align:center">';
  if ( file_exists('config/wait-'.$_SESSION[QT]['language'].'.txt') ) { include 'config/wait-'.$_SESSION[QT]['language'].'.txt'; } else { echo 'Guestbook temporary closed. Please wait...'; }
  echo '</p>';
  echo $qtg_back;
  echo PHP_EOL,'</div>',PHP_EOL;
  include 'qtg_inc_ft.php';
  exit;
}

// INI

$oP->selfname=L('Sign'.$qtg_type);
$oP->selfurl='qtg_msg_add.php';
$oPost = new cPost();

// Map

if ( $qtg_gkey )
{
  include 'qtg_map_lib.php';
  include getLangDir().'qtg_map.php';
  // if used, registers geocoding
  if ( !empty($_POST['geocodes']) )
  {
    if ( empty($_SESSION[QT]['geocodes']) ) $_SESSION[QT]['geocodes']=0;
    $_SESSION[QT]['geocodes'] += (int)$_POST['geocodes'];
    if ( empty($_SESSION[QT]['geocodetime']) ) $_SESSION[QT]['geocodetime']=date('YmdHis', strtotime('+1 day')); // expires tomorrow
  }
}

// --------
// PROCESS POST
// --------

if ( isset($_POST['ok']) )
{
  if ( $_POST['ok']!==makeFormCertificate('3bccd4c53e045fbe250d6c9d9e7ff7be') ) die('Invalid certificate'); // add certificate

  // read values
  if ( isset($_POST['from']) ) $oPost->postfrom = substr(strip_tags(trim($_POST['from'])),0,50);
  if ( isset($_POST['mail']) ) $oPost->useremail = substr(strip_tags(trim($_POST['mail'])),0,50);
  if ( isset($_POST['name']) ) $oPost->name = substr(strip_tags(trim($_POST['name'])),0,50);
  if ( isset($_POST['msg']) )  $oPost->message = strip_tags(trim($_POST['msg']));
  if ( isset($_POST['age']) )
  {
    $_POST['age'] = trim($_POST['age']);
    if ( empty($_POST['age']) ) { $oPost->userage = -1; } else { $oPost->userage = (int)$_POST['age']; }
  }
  // check code text/image/reCAPTCHA
  if ( empty($error) )
  {
    switch($qtg_antispam)
    {
    case 'text':
    case 'image':
      if ( isset($_POST['secu']) ) $_POST['secu'] = substr(trim($_POST['secu']),0,4);
      if ( empty($_POST['secu']) ) $error = L('E_code');
      if ( !isset($_SESSION['textcolor']) || $_SESSION['textcolor']!=sha1($_POST['secu']) ) $error = L('E_code');
      if ( !empty($_SESSION['qtgAuth']) && isset($_POST['secu']) && $_POST['secu']==='0000' ) $error = L('E_code');
      break;
    case 'reCAPTCHAv2':
    case 'reCAPTCHAv3':
      $strResp = isset($_POST['g-recaptcha-response']) ? $_POST['g-recaptcha-response'] : false; // error if recaptcha was not used!
      if ($strResp===false)
      {
        $error = L('reCAPTCHA_failed');
      }
      else
      {
        // ask reCAPTCHA verification result (using secret key)
        $strResp = file_get_contents( 'https://www.google.com/recaptcha/api/siteverify?secret='.urlencode($qtg_antispam==='reCAPTCHAv3' ? $qtg_captcha3sk : $qtg_captcha2sk).'&response='.urlencode($strResp) );
        $arrResp = json_decode($strResp,true);
        $bRes = true;
        if ( empty($arrResp['success']) || $arrResp['success']==='false' ) $bRes=false;
        if ( $bRes )
        {
          // if v3, uses score
          if ( $qtg_antispam==='reCAPTCHAv3' && $arrResp['score']<0.5 ) $error = L('reCAPTCHA_failed'); // error if 'score<0.5' is not in the report
        }
        else
        {
          $error = L('reCAPTCHA_failed'); // error if 'success' is not in the report
        }
      }
    }
  }

  // check values
  if ( empty($error) )
  {
    // mandatory fields
    $oPost->name = QTattr($oPost->name);
    $oPost->message = QTattr($oPost->message);
    if ( empty($oPost->name) ) $error = $L['Name'].' '.L('E_invalid');
    if ( empty($oPost->message) )  $error = $L['Message'].' '.L('E_invalid');
    $oPost->message = str_replace("\r\n\r\n\r\n","\r\n\r\n",$oPost->message);
    $oPost->message = str_replace("\n\n\n","\n\n",$oPost->message);
    if ( !$oPost->CheckMessage($qtg_max_size,2,2) ) $error = $L['E_size'];
    if ( isset($_POST['yx']) ) { $oPost->x = QTgetx($_POST['yx']); $oPost->y = QTgety($_POST['yx']); } else { $oPost->x=0;$oPost->y=0; }
  }

  // check optional fields
  if ( empty($error) && $oPost->userage>=0 ) { if ( !QTisbetween($oPost->userage,1,120) ) $error = $L['Age'].' '.L('E_invalid'); }
  if ( empty($error) && $oPost->useremail!='' ) { if ( !QTismail($oPost->useremail) ) $error = $L['E_email']; }
  if ( empty($error) && $oPost->postfrom!='' ) { $oPost->postfrom = QTattr($oPost->postfrom); }

  // multipost check
  if ( empty($error) && TooMuch($qtg_max_day) ) $error = $L['E_maxday'];

  // flood check
  if ( empty($error) && !LastPostDelayAcceptable(QT_FLOOD) ) $error = $L['E_wait'];

  // check message meaning and url (not for admin)
  if ( empty($error) && $qtg_meaning && empty($_SESSION['qtgAuth']) ) if ( !$oPost->CheckMeaning() ) $error = $L['E_language'];
  if ( empty($error) && $qtg_checkurl && empty($_SESSION['qtgAuth']) ) if ( $oPost->CheckContainsUrl() ) $error = $L['E_language'].'<br><small>(url not allowed)</small>';

  // check message wording
  if ( empty($error) && $qtg_checklang && empty($_SESSION['qtgAuth']) )
  {
    $b=false;
    include getLangDir().'qtg_goodbad.php';
    if ( $oPost->CheckWording($voc) ) $b=true;
    // check other languages if multiple lang allowed
    if ( !$b && $qtg_menulang )
    {
      $arrLangDir = array_keys(LANGUAGES);
      unset($arrLangDir[$_SESSION[QT]['language']]);
      foreach($arrLangDir as $str)
      {
        include getLangDir($str).'qtg_goodbad.php';
        if ( $oPost->CheckWording($voc) ) { $b=true; break; }
      }
    }
    if ( !$b ) $error=$L['E_language'];
  }

  // save value
  if ( empty($error) )
  {
    $_SESSION['qtg_beginedit'] = time()-1;
    $_SESSION['qtg_endedit'] = time()+300;
    if ( $qtg_reviewer ) $oPost->visible='U';
    $oPost->Insert();
    memcacheFlush();

    // notify
    if ( isset($qtg_notify) ) {
    if ( QT_NOTIFYAFTER>0 ) {
    if ( !empty($qtg_notify) ) {

      $strM = date('Ym');
      switch($oDB->type)
      {
      case 'mysql4':
      case 'mysql':
        $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND LEFT(issuedate,6)="'.$strM.'"' );
        $row = $oDB->Getrow();
        $intCount = $row['countid'];
        break;
      case 'sqlsrv':
      case 'mssql':
        $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND LEFT(issuedate,6)="'.$strM.'"' );
        $row = $oDB->Getrow();
        $intCount = $row['countid'];
        break;
      case 'pg':
        $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTRING(issuedate,1,6)="'.$strM.'"' );
        $row = $oDB->Getrow();
        $intCount = $row['countid'];
        break;
      case 'sqlite':
        $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTR(issuedate,1,6)="'.$strM.'"' );
        $row = $oDB->Getrow();
        $intCount = $row['countid'];
        break;
      case 'oci':
        $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND SUBSTR(issuedate,1,6)="'.$strM.'"' );
        $row = $oDB->Getrow();
        $intCount = $row['countid'];
        break;
      case 'file':
        $intCount = $oDB->FilesCount('',QT_NOTIFYAFTER+1,$strM,$strM,false); // count files this month (can stop counting if more that QT_NOTIFYAFTER)
        break;
      default: $intCount=0; //continue without notification
      }
      if ( $intCount==QT_NOTIFYAFTER ) mail( $qtg_notify,'Notification from QuickTalk guestbook ',$intCount.' messages registering this month.' );

    }}}

    // exit
    if ( $qtg_reviewer ) HtmlRedirect('qtg_msg_view.php?id='.cPost::Hash($oPost->id));
    include 'qtg_inc_hd.php';
    echo '<div class="content">',PHP_EOL;
    echo '<div class="title">',L('Message_send'),'</div><script type="text/javascript">setTimeout(\'window.location=document.getElementById("exiturl").href\',4000);</script>',PHP_EOL;
    echo $qtg_back;
    echo '</div>',PHP_EOL;
    include 'qtg_inc_ft.php';
    exit;
  }

}

// --------
// HTML START
// --------

// Using reCAPTCHA (sitekey is the public key)
if ( $qtg_antispam==='reCAPTCHAv2' )
{
$oHtml->scripts[] = '<script type="text/javascript">
var onloadCallback = function() { grecaptcha.render("reCAPTCHAv2",{"sitekey" : "'.$qtg_captcha2pk.'"}); };
</script>
';
}
if ( $qtg_antispam==='reCAPTCHAv3' )
{
$oHtml->scripts[] = '<script src="https://www.google.com/recaptcha/api.js?render='.$qtg_captcha3pk.'"></script>
<script>
grecaptcha.ready(function() {
  grecaptcha.execute("'.$qtg_captcha3pk.'", {action: "registration"}).then(function(token) {
  // pass the token to the backend script for verification
  document.getElementById("g-recaptcha-response").value = token;
  });
});
</script>
';
}

include 'qtg_inc_hd.php';
echo PHP_EOL,'<div class="content">',PHP_EOL;

echo '<div class="title">',$oP->selfname,'</div>
<div id="msg-add">
';

  if ( !empty($error) ) echo '<p class="error" style="text-align:center">',$error,'</p>';
  $id=0;
  if ( !$qtg_actif ) echo '<p class="warning" style="text-align:center"><i class="qtg-icon icon-attention"></i> Application closed. Only administrator can add message.</p>';
  $formaction = Href('qtg_msg_add.php');
  //------
  $certificate = makeFormCertificate('3bccd4c53e045fbe250d6c9d9e7ff7be');
  include 'qtg_form_msg.php';
  //------

echo $qtg_back;
echo '</div>';

// --------
// HTML END
// --------

 echo PHP_EOL,'</div>',PHP_EOL;
 include 'qtg_inc_ft.php';