<?php
// QuickTalk Guestbook 4.0.3 build:20220105
session_start();
/**
 * @var cVIP $oP
 * @var cHtml $oHtml
 * @var array $L
 * @var cDB $oDB
 */
require 'qtg_init.php';

// Check if using the administration section

$bAdm = isset($_GET['adm']);
if ( $bAdm && empty($_SESSION['qtgAuth']) ) $bAdm=false;

// Check argument

$ok = '';
$id = '-1'; // in case of file system, id is a filename (hashed)
$page = 1;
QThttp('ok id int:page',true,false); //only Http Get
if ( $id<0 ) die('ID '.L('E_invalid'));

$oP->selfname=L('Delete_my_message');
$oP->selfurl='qtg_msg_del.php';

// Setting for administration section

if ( $bAdm )
{
  include getLangDir().'qtg_adm.php';
  $qtg_skin = 'bin/css';
  $oP->selfname=$L['Delete'];
}

// Get the messages

$oPost = new cPost($id);

// Check permissions

if ( empty($_SESSION['qtgAuth']) )
{
  if ( $_SERVER['REMOTE_ADDR']!=$oPost->ip )
  {
  echo 'This is not your message...<br>'.$qtg_back;
  exit;
  }
  if ( !isset($_SESSION['qtg_beginedit']) || !isset($_SESSION['qtg_endedit']) || time()+0>$_SESSION['qtg_endedit'] )
  {
  echo 'Out of time...<br>'.$qtg_back;
  exit;
  }
}

// --------
// SUBMITTED
// --------

if ( !empty($ok) )
{
  $oPost->Delete();
  memcacheFlush();
  if ( $bAdm ) { HtmlRedirect('qtg_adm_msg.php'); } else { HtmlRedirect(); }
  exit;
}

// --------
// HTML START
// --------

if ( $bAdm )
{
  include 'qtg_adm_inc_hd.php';
}
else
{
  include 'qtg_inc_hd.php';
}
echo PHP_EOL,'<div class="content">',PHP_EOL;

echo '
<div id="msg-add">
';

if ( !$bAdm ) echo '<div class="title">',$oP->selfname,'</div>
';

$qtg_gkey=''; // disable map
$qtg_show_size=null; // show full message
// ------------
if ( empty($id) ) $id = cPost::Hash($oPost->id);
$intMsg = strlen($oPost->message);
echo '<div class="msg">',PHP_EOL;
echo '<p class="msg-header">',RenderMsgHeader($oPost,$qtg_use_from),'</p>',PHP_EOL;
echo '<p class="msg-body" id="msg-',$id,'">',RenderMsg($oPost->message,$qtg_show_size,$qtg_tags,'<small>...</small>',$qtg_skin),MoreLink($intMsg,$qtg_show_size,$id,$page),'</p>',PHP_EOL;
echo '<p class="msg-footer">',RenderMsgFooter($oPost,$qtg_use_email,$qtg_use_age,$qtg_gkey),'</p>',PHP_EOL;
echo '</div>',PHP_EOL;
if ( $intMsg>$qtg_show_size && $intMsg<$qtg_show_size*3 && $intMsg<801 ) echo '<div style="display:none" id="fullmsg-',$id,'">',RenderMsg($oPost->message,800,$qtg_tags,'',$qtg_skin),' <a class="more-link" href="javascript:void(0);" onclick="msgSwitch(\'',$id,'\');">',L('Less'),'</a></div>',PHP_EOL;
// ------------
echo '<div class="button action"><a href="',Href('qtg_msg_del.php'),'?',($bAdm ? 'adm&amp;' : ''),'id=',$id,'&amp;page=',$page,'&amp;ok=delete">'.$L['Delete'].' !</a></div>
<br>
<br>
';

if ( !$bAdm) echo $qtg_back;

echo '</div>';

// --------
// HTML END
// --------

echo PHP_EOL,'</div>',PHP_EOL;
include 'qtg_inc_ft.php';