<?php
// QuickTalk Guestbook 4.0.3 build:20220105
session_start();
/**
 * @var cVIP $oP
 * @var cHtml $oHtml
 * @var array $L
 * @var cDB $oDB
 */
require 'qtg_init.php';

// Check if using the administration section

$bAdm = isset($_GET['adm']);
if ( $bAdm && empty($_SESSION['qtgAuth']) ) $bAdm=false;

// Check argument

$ok = '';
$id = '-1'; // in case of file system, id is a filename (hashed)
$page = 1;
QThttp('ok id int:page');
if ( $id<0 ) die('ID '.L('E_invalid'));

$oP->selfname=L('Edit_my_message');
$oP->selfurl='qtg_msg_edit';

// Setting for administration section

if ( $bAdm )
{
  include getLangDir().'qtg_adm.php';
  $qtg_skin = 'bin/css';
  $oP->selfname=$L['Edit'];
}

// Get the message

$oPost = new cPost($id);

// Check permissions

if ( empty($_SESSION['qtgAuth']) )
{
  if ( $_SERVER['REMOTE_ADDR']!=$oPost->ip ) { echo 'This is not your message...<br>'.$qtg_back; exit; }
  if ( !isset($_SESSION['qtg_beginedit']) || !isset($_SESSION['qtg_endedit']) || time()+0>$_SESSION['qtg_endedit'] ) { echo 'Out of time...<br>'.$qtg_back; exit; }
}

// Map

if ( $qtg_gkey )
{
  include 'qtg_map_lib.php';
  include getLangDir().'qtg_map.php';
  if ( empty($_SESSION[QT]['geocodes']) ) $_SESSION[QT]['geocodes']=0;
}

// --------
// SUBMITTED
// --------

if ( !empty($ok) )
{
  if ( $ok!==makeFormCertificate('bfaa317f62e9cc73a649a45124c9a050') ) die('Invalid certificate');  // edit certificate
  // read values
  $bResetdate = isset($_POST['resetdate']) && $_POST['resetdate']==='y';
  if ( isset($_POST['from']) ) $oPost->postfrom = substr(strip_tags(trim($_POST['from'])),0,50);
  if ( isset($_POST['mail']) ) $oPost->useremail = substr(strip_tags(trim($_POST['mail'])),0,50);
  if ( isset($_POST['name']) ) $oPost->name = substr(strip_tags(trim($_POST['name'])),0,50);
  if ( isset($_POST['msg']) )  $oPost->message = strip_tags(trim($_POST['msg']));
  if ( isset($_POST['visible']) && !empty($_SESSION['qtgAuth']) ) $oPost->visible = 'Y';
  if ( isset($_POST['age']) ) { $_POST['age'] = trim($_POST['age']); $oPost->userage = empty($_POST['age']) ? -1 : (int)$_POST['age']; }
  // check code
  if ( empty($error) && empty($_SESSION['qtgAuth']) && $qtg_antispam!=='none')
  {
    $int = isset($_POST['secu']) ? (int)substr(trim($_POST['secu']),0,4) : -1;
    if ( !QTisbetween($int,0,9999) ) $error=L('E_code');
    if ( !isset($_SESSION['textcolor']) || $_SESSION['textcolor']!=sha1($int) ) $error=L('E_code');
  }

  // read values
  if ( empty($error) )
  {
    // mandatory fields
    $oPost->name = QTattr($oPost->name);
    $oPost->message = QTattr($oPost->message);
    if ( empty($oPost->name) ) $error = $L['Name'].' '.L('E_invalid');
    if ( empty($oPost->message) )  $error = $L['Message'].' '.L('E_invalid');
    $oPost->message = str_replace("\r\n\r\n\r\n","\r\n\r\n",$oPost->message);
    $oPost->message = str_replace("\n\n\n","\n\n",$oPost->message);
    if ( !$oPost->CheckMessage($qtg_max_size,2,2) ) $error = L('E_size');
    if ( isset($_POST['yx']) ) { $oPost->x = QTgetx($_POST['yx'],0); $oPost->y = QTgety($_POST['yx'],0); } else { $oPost->x=0;$oPost->y=0; }
    if ( isset($_POST['geocodes']) )
    {
      $_SESSION[QT]['geocodes'] += (int)$_POST['geocodes'];
      if ( empty($_SESSION[QT]['geocodetime']) ) $_SESSION[QT]['geocodetime']=date('YmdHis');
    }
  }

  // check optional fields
  if ( empty($error) && $oPost->userage>=0 ) { if ( !QTisbetween($oPost->userage,1,120) ) $error = $L['Age'].' '.L('E_invalid'); }
  if ( empty($error) && $oPost->useremail!='' ) { if ( !QTismail($oPost->useremail) ) $error = $L['Email'].' '.L('E_invalid'); }
  if ( empty($error) && $oPost->postfrom!='' ) { $oPost->postfrom = QTattr($oPost->postfrom); }

  // multipost check
  if ( empty($_SESSION['qtgAuth']) ) if ( empty($error) && TooMuch($qtg_max_day) ) $error = $L['E_maxday'];

  // flood check
  if ( empty($_SESSION['qtgAuth']) ) if ( empty($error) && !LastPostDelayAcceptable(QT_FLOOD) ) $error = $L['E_wait'];

  // check message meaning and url
  if ( empty($error) && $qtg_meaning && empty($_SESSION['qtgAuth']) ) if ( !$oPost->CheckMeaning() ) $error = $L['E_language'];
  if ( empty($error) && $qtg_checkurl && empty($_SESSION['qtgAuth']) ) if ( $oPost->CheckContainsUrl() ) $error = $L['E_language'].'<br><small>(url not allowed)</small>';

  // check message wording
  if ( empty($error) && $qtg_checklang && empty($_SESSION['qtgAuth']) )
  {
    $b=false;
    include getLangDir().'qtg_goodbad.php';
    if ( $oPost->CheckWording($voc) ) $b=true;
    // check other languages if multiple lang allowed
    if ( !$b && $qtg_menulang )
    {
      $arrLangDir = array_keys(LANGUAGES);
      unset($arrLangDir[$_SESSION[QT]['language']]);
      foreach($arrLangDir as $str)
      {
      include getLangDir($str).'qtg_goodbad.php';
      if ( $oPost->CheckWording($voc) ) { $b=true; break; }
      }
    }
    if ( !$b ) $error=$L['E_language'];
  }

  // save value
  if ( empty($error) )
  {
    $_SESSION['qtg_endedit'] = time()+300;
    $oPost->Update($bResetdate);
    memcacheFlush();
    // exit
    if ( $bAdm )
    {
    $_SESSION[QT.'pagedialog'] = 'O|'.$L['S_update'];
    $oHtml->Redirect('qtg_adm_msg.php');
    }
    else
    {
    include 'qtg_inc_hd.php';
    echo '<div class="content">',PHP_EOL;
    echo '<div class="title">',L('Message_send'),'</div><script type="text/javascript">setTimeout(\'window.location=document.getElementById("exiturl").href\',4000);</script>',PHP_EOL;
    echo $qtg_back;
    echo '</div>',PHP_EOL;
    include 'qtg_inc_ft.php';
    }
    exit;
  }

}

// --------
// HTML START
// --------

if ( $bAdm ) { include 'qtg_adm_inc_hd.php';} else { include 'qtg_inc_hd.php'; }

echo PHP_EOL,'<div class="content">',PHP_EOL;
if ( !$bAdm)
{
echo '<div class="title">',$oP->selfname,'</div>
';
}
echo '<div id="msg-add">
';

// Force all fields in admin edit mode, else check user and time

if ( $bAdm )
{
  $qtg_use_age=true;
  $qtg_use_from=true;
  $qtg_use_from_type=0;
  $qtg_use_email=true;
  $qtg_bbc_bold=true ;
  $qtg_bbc_italic=true;
  $qtg_bbc_underline=true;
  $qtg_bbc_url=true;
}
else
{
  if ( empty($_SESSION['qtgAuth']) )
  {
    // CHECK USER AND TIME
    if ($_SERVER['REMOTE_ADDR']!=$oPost->ip)
    {
    echo 'This is not your message...<br>'.$qtg_back;
    include 'qtg_inc_ft.php';
    exit;
    }
    if ( !isset($_SESSION['qtg_beginedit']) || !isset($_SESSION['qtg_endedit']) )
    {
    echo 'Out of time...<br>',$qtg_back;
    include 'qtg_inc_ft.php';
    exit;
    }
    if ( time()+0>$_SESSION['qtg_endedit'] )
    {
    echo 'Out of time...<br>',$qtg_back;
    include 'qtg_inc_ft.php';
    exit;
    }
  }
}

if ( $qtg_gkey )
{
  if ( $oPost->x==0 && $oPost->y==0 )
  {
  $x = QTgetx($qtg_gcenter);
  $y = QTgety($qtg_gcenter);
  }
  else
  {
  $x = $oPost->x;
  $y = $oPost->y;
  $aPoint = MakePoint( $y, $x, $oPost->name, '', (isset($qtg_gsymbol) ? $qtg_gsymbol : false) );
  $arrCoord[$id] = $aPoint;
  }
}

if ( !empty($error) ) echo '<p class="error" style="text-align:center">',$error,'</p>';

$formaction = Href('qtg_msg_edit.php');
// --------
$certificate = makeFormCertificate('bfaa317f62e9cc73a649a45124c9a050');
include 'qtg_form_msg.php';
// --------

// --------
// HTML END
// --------

if ( !$bAdm) echo $qtg_back;

echo '</div>';
echo PHP_EOL,'</div>',PHP_EOL;
include 'qtg_inc_ft.php';