<?php
// QuickTalk Guestbook 4.0.3 build:20220105
session_start();
/**
 * @var cVIP $oP
 * @var cHtml $oHtml
 * @var array $L
 * @var cDB $oDB
 */
require 'qtg_init.php';

$id = '-1'; // in case of file system, id is a string (hashed)
$page = 1;
QThttp('id int:page', true,false); //only Http Get
if ( $id<0 ) die('ID '.L('E_invalid'));

$oP->selfurl='qtg_msg_view.php';
if ( isset($_GET['adm']) ) $oP->exiturl = 'qtg_adm_msg.php';

// MAP

if ( $qtg_gkey )
{
  include 'qtg_map_lib.php';
  include getLangDir().'qtg_map.php';
}

// --------
// HTML START
// --------
$oPost = new cPost($id);
$intMessages=1;

if ( $qtg_gkey ) {
if ( $oPost->x!=0 && $oPost->y!=0 ) {

  $strPname = QTattr($oPost->name,25);
  $strPlink = '<a href="http://maps.google.com?q='.$oPost->y.','.$oPost->x.'+('.$strPname.')" class="small" title="'.$L['map_In_google'].'" target="_blank">[G]</a>';
  $strPtxt = QTattr(QTinline($oPost->message,150,' ')).($qtg_use_from && !empty($oPost->postfrom) ? '<br>'.QTattr($oPost->postfrom) : '');
  $strPtxt = str_replace("\r\n"," ",$strPtxt);
  $strPtxt = str_replace("\n"," ",$strPtxt);
  $aPoint = MakePoint( $oPost->y, $oPost->x, $oPost->name, '<div class="ginfo"><b>'.$strPname.'</b><br>'.$strPtxt.'<br>'.QTdatestr($oPost->issuedate,FORMATDATE,FORMATTIME,true).' '.$strPlink.'</div>', (isset($qtg_gsymbol) ? $qtg_gsymbol : false) );
  $arrCoord[$id] = $aPoint;

}}

include 'qtg_inc_hd.php';
echo PHP_EOL,'<div class="content">',PHP_EOL;
if ( $oPost->visible=='U' )
{
  echo '<div class="title">',L('Message_send'),'</div><p>',L('Message_review'),'</p>',PHP_EOL;
}
else
{
  echo '<div class="title">',L('Message'),'</div>',PHP_EOL;
}

echo '
<div class="messages column">
';

// ------------
$qtg_show_size=0; // no cut
if ( empty($id) ) $id = cPost::Hash($oPost->id);
$intMsg = strlen($oPost->message);
echo '<div class="msg">',PHP_EOL;
echo '<p class="msg-header">',RenderMsgHeader($oPost,$qtg_use_from),'</p>',PHP_EOL;
echo '<p class="msg-body" id="msg-',$id,'">',RenderMsg($oPost->message,$qtg_show_size,$qtg_tags,'<small>...</small>',$qtg_skin),MoreLink($intMsg,$qtg_show_size,$id,$page),'</p>',PHP_EOL;
echo '<p class="msg-footer">',RenderMsgFooter($oPost,$qtg_use_email,$qtg_use_age,$qtg_gkey),'</p>',PHP_EOL;
echo '</div>',PHP_EOL;
if ( $intMsg>$qtg_show_size && $intMsg<$qtg_show_size*3 && $intMsg<801 ) echo '<div style="display:none" id="fullmsg-',$id,'">',RenderMsg($oPost->message,800,$qtg_tags,'',$qtg_skin),' <a class="more-link" href="javascript:void(0);" onclick="msgSwitch(\'',$id,'\');">',L('Less'),'</a></div>',PHP_EOL;
// ------------

echo '</div>
';

if ( $qtg_gkey )
{
  if ( count($arrCoord)==0 )
  {
    echo '<p class="mapempty">',L('map_E_noposition'),'</p>';
  }
  else
  {
    //select zoomto (maximum 20 items in the list)
    if ( count($arrCoord)>1 )
    {
      $str = '<p class="gmap" style="margin:0 0 4px 0"><a class="gmap" href="javascript:void(0)" onclick="zoomToFullExtend(); return false;">'.L('map_zoomtoall').'</a> | '.L('map_jumpto').' <select class="gmap" id="zoomto" name="zoomto" size="1" onchange="map.setCenter(eval(this.value));">';
      $str .= '<option value="new GLatLng('.QTgety($qtg_gcenter).','.QTgetx($qtg_gcenter).')"> </option>';
      $i=0;
      foreach($arrCoord as $aPoint)
      {
      $str .= '<option value="new GLatLng('.$aPoint['y'].','.$aPoint['x'].')">'.$aPoint['title'].'</option>';
      $i++; if ( $i>20 ) break;
      }
      $str .= '</select></p>';
    }

    echo '
    <div class="gmap">
    ',( count($arrCoord)>1 ? $str :'' ),'
    <div id="map_canvas"></div>
    <p class="gmap" style="margin:4px 0 0 0">',sprintf($L['map_items'],L('message',count($arrCoord)),L('message',$intMessages) ),'</p>
    </div>
    ';
  }
}

echo '<div class="button back"><a id="exiturl" href="'.Href($oP->exiturl).'?page='.$page.'">'.L('Return'.$qtg_type).'</a></div>';

// --------
// HTML END
// --------

if ( $qtg_gkey && count($arrCoord)>0 )
{
  // check new map center
  $y = floatval(QTgety($qtg_gcenter));
  $x = floatval(QTgetx($qtg_gcenter));

  // center on the first item
  foreach($arrCoord as $aPoint)
  {
    if ( !empty($aPoint['y']) && !empty($aPoint['x']) )
    {
    $y=$aPoint['y'];
    $x=$aPoint['x'];
    break;
    }
  }
  // update center
  $qtg_gcenter=$y.','.$x;

  // load markers
  $gmap_markers = array();
  $gmap_events = array();
  $gmap_functions = array();
  foreach($arrCoord as $aPoint)
  {
    if ( !empty($aPoint['y']) && !empty($aPoint['x']) )
    {
    $gmap_markers[] = QTgmapMarker($aPoint['y'].','.$aPoint['x'],false,$qtg_gsymbol,$aPoint['title'],$aPoint['info']);
    }
  }
  include 'qtg_map_load.php';
}

echo PHP_EOL,'</div>',PHP_EOL;
include 'qtg_inc_ft.php';