<?php

/**
 * PHP versions 4 and 5
 * This script is a add-on for the QuickTalk guestbook application version 2.5 (or next).
 *
 * WARNING:
 * This computer program is protected by copyright law and international treaties.
 * Unauthorized reproduction or distribution of this program, or any portion of it,
 * may result in severe civil and criminal penalties,
 * and will be prosecuted to the maximum extent possible under the law.
 *
 * @package    QTG API
 * @author     Q-code <info@q-code.be>
 * @copyright  2014 Q-code
 * @version    4.0 build:20200514
 */

// Check application path

$strCWD = getcwd(); //From here we run as if we are in the application directory (an no more as simple include)
if ( empty($qtgapi_path) ) { $qtgapi_path=''; } else { if ( substr($qtgapi_path,-1,1)!='/' ) $qtgapi_path .= '/'; }

// include ini

if ( !empty($qtgapi_path) ) chdir($qtgapi_path);
if ( !file_exists('qtg_init.php') ) die('Application not found. Check your $qtgapi_path configuraion.');
require 'qtg_init.php';

// ---------
// INITIALISE
// ---------

if ( !isset($qtgapi_head) ) $qtgapi_head = false;
if ( !isset($qtgapi_css) ) $qtgapi_css = true;
if ( !isset($qtgapi_banner) ) $qtgapi_banner = true;
if ( !isset($qtgapi_count) ) $qtgapi_count = 5;
if ( !isset($qtgapi_char) ) $qtgapi_char = 200;
if ( !isset($qtgapi_truncatelink) ) $qtgapi_truncatelink = true;
if ( !isset($qtgapi_newline) ) $qtgapi_newline = false;
if ( !isset($qtgapi_username) ) $qtgapi_username = true;
if ( !isset($qtgapi_backlink) ) $qtgapi_backlink = true;
if ( !isset($qtgapi_script) ) $qtgapi_script = '';

// COUNT TOPICS

$intMessages = 0;
if ( QT_FILE )
{
  $intMessages = $oDB->FilesCount('y'); // this uses GetFiles(), thus $oDT->arrFiles is created!
}
else
{
  $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="Y"' );
  $row = $oDB->Getrow();
  $intMessages = intval($row['countid']);
}

// --------
// HTML START
// --------

if ( $qtgapi_head ) echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr" xml:lang="en">
<head>
';
if ( $qtgapi_css ) echo '<link rel="stylesheet" type="text/css" href="',$qtgapi_path,'qtgapi.css"/>';
if ( !empty($qtgapi_script) ) echo $qtgapi_script;
if ( $qtgapi_head ) echo '</head>';

echo '
<div class="qtgapi">
';

// Display banner

if ($qtgapi_banner)
{
echo '
<div class="banner"><img src="',$qtgapi_path,'qtgapi.gif" width="175" height="50" alt="QuickTalk Guestbook"/></div>
';
}

// Display no messages

if ( $intMessages==0 )
{
  echo '<p class="small">no message</p>';
  if ( $qtgapi_head ) echo '</body></html>';
  exit;
}


// Display messages

echo '
<div class="messages">
';

if ( QT_FILE )
{
  // $oDB->GetFiles('y'); GetList is already done by the count
  rsort($oDB->arrFiles);
  if ( count($oDB->arrFiles)>$qtgapi_count ) $oDB->arrFiles = array_slice($oDB->arrFiles, 0, $qtgapi_count);
  $oDB->curFiles=0;
}
else
{
  $oDB->Query( LimitSQL('* FROM '.TABMESSAGE.' WHERE id>=0 AND visible="Y"','issuedate DESC',0,$qtgapi_count) );
}

$i = 0;
while($row=$oDB->Getrow())
{
  $oPost = new cPost($row);
  if ( QT_FILE ) $oPost->id = cPost::Hash($oPost->id); // from here id is only used in url

  // Build signature and date
  $strSign = '<span class="messagedate">'.QTdatestr($oPost->issuedate,FORMATDATE,FORMATTIME,true,true).'</span>';
  if ( $qtgapi_username ) $strSign = '<span class="messagesign">'.$oPost->name.'</span> '.$strSign;

  // Build message
  $strMessage = RenderMsg($oPost->message,$qtgapi_char,$qtg_tags,'...',$qtg_skin,($qtgapi_newline ? '<br>' : ' '));
  if ( $qtgapi_truncatelink && strlen($oPost->message)>$qtgapi_char ) $strMessage .= MoreLink(strlen($oPost->message),$qtgapi_char,cPost::Hash($oPost->id),0,$true);

  if ( !empty($qtgapi_path) )
  {
    if ( strstr($strMessage,'href="') ) $strMessage = str_replace('href="','href="'.$qtgapi_path,$strMessage);
    if ( strstr($strMessage,'src="') ) $strMessage = str_replace('src="','src="'.$qtgapi_path,$strMessage);
    if ( strstr($strMessage,'http') )
    {
    $strMessage = str_replace('href="'.$qtgapi_path.'http://','href="http://',$strMessage);
    $strMessage = str_replace('href="'.$qtgapi_path.'https://','href="https://',$strMessage);
    }
  }

  // Show message
  echo '
  <div class="message">
  <p class="messageinfo">',$strSign,'</p>
  <p class="messagebody">',$strMessage,'</p>
  </div>
  ';
  $i++;
  if ( $i>=$qtgapi_count ) break;
}

echo '
</div>
';

// --------
// HTML END
// --------

if ( $qtgapi_backlink )
{
if ( !is_string($qtgapi_backlink) ) $qtgapi_backlink=$qtg_title;
echo '
<div class="footer"><p class="footer"><a class="footer" href="',$qtgapi_path,'qtg_index.php">',$qtgapi_backlink,'</a></p></div>
';
}

echo '</div>
';

if ( $qtgapi_head ) echo '</body></html>';

if ( !empty($qtgapi_path) ) chdir($strCWD);